﻿var reloadManageViewShowDivForLoading = false;
var closeBulkDialog = false;
var reloadTheTickets = false;

$(document).ready(function () {
    // ---- SignalR --------

    //// Create a function that the hub can call back to display messages.
    $.connection.ticketListHub.client.newTicketCreated = function (ticketId, ticketREF, notify) {
        //$.playSound(RQ_URL + '/Sounds/ticket.mp3');
        if (notify) {
            //Nové požadavky +1
            var count = parseInt($('#affected-tickets-info #new-tickets-async .like-badge').text());
            $('#affected-tickets-info #new-tickets-async .like-badge').text(count + 1);
            setPageTitleBadge(count + 1);

            $('#affected-tickets-info #new-tickets-async .tickets-list').append('<a href="' + RQ_URL + '/Tickets/Show/' + ticketREF + '">' + ticketREF + '</a>');

            if (!$('#affected-tickets-info').is(":visible")) {
                $('#affected-tickets-info').slideDown('medium');
            }

            if (!$('#affected-tickets-info #new-tickets-async').is(":visible")) {
                $('#affected-tickets-info #new-tickets-async').show();
            }

            for (var i = 0; i < 5; i++) {
                $('#affected-tickets-info #new-tickets-async .fa-stack').fadeOut(500).fadeIn(500);
            }
        }

        if ($('#hiddenArchive').val() != 'True') { //pokud je vybrany archiv, signalR pocty pozadavku neresim

            if (notify)
                $('li#AllTickets.selected').removeClass('fresh').addClass('changed');

            //Všechny požadavky +1 
            //var count = parseInt($('li#AllTickets .badge').text());
            //$('li#AllTickets .badge').text(count + 1);
            if ($('li#AllTickets').hasClass('selected')) {
                refreshViewTicketsCount(null); //null == AllTickets
            }

            makeModel();
            var model = $('#ticketsForm').serializeObject();

            var viewIds = [];

            $('ul.personal-views:visible li.personal-view.selected').each(function () {
                viewIds.push($(this).data('id'));
            });

            $.post(
                RQ_URL + "/Tickets/CheckNewTicket",
                {
                    ticketId: ticketId,
                    viewIds: viewIds,
                    model: model,
                },
                function (data) {
                    $(data.affectedViews).each(function () {
                        var $li = $('ul.personal-views:visible li.personal-view[data-id=' + this + ']');
                        //var $liCount = $li.find('.tickets-count');

                        //var count = parseInt($liCount.text());
                        //$liCount.text(count + 1);
                        refreshViewTicketsCount(this);
                        $li.removeClass('fresh').addClass('changed');
                    });

                    if (data.newTicketRow != null) {
                        $('#tickets-table tbody').prepend(data.newTicketRow);

                        if (notify) {
                            var $tr = $('#tickets-table tr.ticket-row[data-ticket-id="' + ticketId + '"]');
                            $tr.addClass('async');
                        }
                    }
                },
                "json"
            )
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
        }
    };

    $.connection.ticketListHub.client.addTicketUserMessage = function (ticketId, ticketREF) {
        //$.playSound(RQ_URL + '/Sounds/ticket-user-message.mp3');

        //Nové komentáře +1
        var count = parseInt($('#affected-tickets-info #new-ticket-user-messages-async .like-badge').text());
        $('#affected-tickets-info #new-ticket-user-messages-async .like-badge').text(count + 1);

        $('#affected-tickets-info #new-ticket-user-messages-async .tickets-list').append('<a href="' + RQ_URL + '/Tickets/Show/' + ticketREF + '">' + ticketREF + '</a>');

        if (!$('#affected-tickets-info').is(":visible")) {
            $('#affected-tickets-info').slideDown('medium');
        }

        if (!$('#affected-tickets-info #new-ticket-user-messages-async').is(":visible")) {
            $('#affected-tickets-info #new-ticket-user-messages-async').show();
        }

        for (var i = 0; i < 5; i++) {
            $('#affected-tickets-info #new-ticket-user-messages-async .fa-stack').fadeOut(500).fadeIn(500);
        }
    };

    $.connection.ticketListHub.client.viewsCountCanBeChanged = function (data, notify) {
        if ($('#hiddenArchive').val() == 'True') //pokud je vybrany archiv, signalR pocty pozadavku neresim
            return;

        $(data).each(function () {
            var $li = $('ul.personal-views:visible li.personal-view[data-id=' + this.viewId + ']');

            if ($li.hasClass('selected')) {
                var $liCount = $li.find('.tickets-count');
                var count = parseInt($liCount.text());

                $.ajax({
                    url: RQ_URL + '/Tickets/LoadCountForView?viewId=' + this.viewId + '&dataSource=' + VIEW + '&archived=' + $('#hiddenArchive').val() + '&refresh=true',
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                }).done(function (data) {
                    if (!data.error) {
                        var $lbTicketsCount = $li.find(".tickets-count");

                        if (data.viewIsComplete) {
                            $lbTicketsCount.text(data.count);

                            if (count != data.count) {
                                if (notify) {
                                    $li.removeClass('fresh').addClass('changed');
                                    $li.find('.badge').fadeIn();
                                }
                                else {
                                    $li.addClass('fresh');
                                }
                            }
                        }
                        else {
                            $lbTicketsCount.text("-");
                        }
                    }
                })
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { console.log(error.responseText); }
                });

            }
        });
    };

    $.connection.ticketListHub.client.ticketHasChanged = function (ticketId, notify, whatHasChanged) {
        var $tr = $('#tickets-table tr.ticket-row[data-ticket-id="' + ticketId + '"]');

        if ($tr.length == 1) {
            makeModel();
            var model = $('#ticketsForm').serializeObject();

            $.post(
                RQ_URL + "/Tickets/CheckTicketInTable",
                {
                    ticketId: ticketId,
                    model: model,
                },
                function (data) {
                    if (data.ticketRow != null) {
                        var $tr_new = $(data.ticketRow);

                        switch (whatHasChanged) {
                            case "TicketStateChanged":
                                $tr.find('.ticket-status').replaceWith($tr_new.find('.ticket-status'));
                                break;

                            case "NewMessageAdded":
                                $tr.find('td[class^="ticket-type-"]').toggleClass('ticket-read', $tr_new.find('td[class^="ticket-type-"]').hasClass('ticket-read'));
                                $tr.find('.ticketMiniIcon.messagesCount .number').text($tr_new.find('.ticketMiniIcon.messagesCount .number').text());
                                $tr.find('.ticketMiniIcon.messagesCount').show();
                                break;

                            case "TicketRead":
                                $tr.find('td[class^="ticket-type-"]').toggleClass('ticket-read', $tr_new.find('td[class^="ticket-type-"]').hasClass('ticket-read'));
                                break;

                            case "NewStickyNoteAdded":
                            case "NewPrivateStickyNoteAdded":
                                $tr.find('.ticketMiniIcon.stickyNotesCount .number').text($tr_new.find('.ticketMiniIcon.stickyNotesCount .number').text());
                                $tr.find('.ticketMiniIcon.stickyNotesCount').show();
                                break;
                        }


                        if (notify) {
                            switch (whatHasChanged) {
                                case "TicketStateChanged":
                                    $ticketStatus = $tr.find('.ticket-status')
                                    $ticketStatus.removeClass('async');
                                    setTimeout(function () { $ticketStatus.addClass('async'); }, 10);
                                    break;

                                case "NewMessageAdded":
                                    $messagesCount = $tr.find('.ticketMiniIcon.messagesCount');
                                    $messagesCount.removeClass('async');
                                    setTimeout(function () { $messagesCount.addClass('async'); }, 10);
                                    break;

                                case "NewStickyNoteAdded":
                                    $stickyNotesCount = $tr.find('.ticketMiniIcon.stickyNotesCount');
                                    $stickyNotesCount.removeClass('async');
                                    setTimeout(function () { $stickyNotesCount.addClass('async'); }, 10);
                                    break;
                            }

                            //$.playSound(RQ_URL + '/Sounds/ticket.mp3');
                        }
                    }
                    else { //vypadl z pohledu, nebo uplne i ze vsech pozadavku (ztraceno opravneni)
                        if (automaticRefreshRemoveLostTicketFromTable)
                            $tr.remove();
                        else
                            $tr.addClass('grayout');
                    }
                },
                "json"
            )
            .fail(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
        }
    };

    //$.connection.hub.start(); vola se pouze jednou z hlavniho _Layout



    // ------------------- --------- ----------------------------------

    setInterval(function () {
        refreshTicketAgeTexts();
    }, 1000 * 60);

    $('#tabActiveTickets').click(function () {
        $('#tabArchivedTickets').removeClass('active');
        $(this).addClass('active');
        $('#hiddenArchive').val('False');
        reloadViewActiveOrArchiveTab();
        $('#tickets-table-toolbar a.archive').prop('disabled', false);
        $('#tickets-table-toolbar a.unarchive').prop('disabled', true);
        ticketIdsArray = new Array();
        RefreshTicketCheckboxAllCount();
    });

    $('#tabArchivedTickets').click(function () {
        $('#tabActiveTickets').removeClass('active');
        $(this).addClass('active');
        $('#hiddenArchive').val('True');
        reloadViewActiveOrArchiveTab();
        $('#tickets-table-toolbar a.archive').prop('disabled', true);
        $('#tickets-table-toolbar a.unarchive').prop('disabled', false);
        ticketIdsArray = new Array();
        RefreshTicketCheckboxAllCount();
    });

    $('#sidebar-full .sidebar-change-icon').click(function () {
        $('#lbReducedText').text($('.sidebar-block .sidebar-menu-item.active').text());
        $('#sidebar-full').hide();
        $('#tickets-sidebar').removeClass('full');
        $('#tickets-sidebar').addClass('reduced');
        $('#sidebar-reduced').show();
        $.cookie("TicketListParamsCookieSideBar-" + LoggedUserProviderKey, "reduced", { expires: 365 });
    });

    $('#sidebar-reduced .sidebar-change-icon').click(function () {
        $('#sidebar-reduced').hide();
        $('#tickets-sidebar').removeClass('reduced');
        $('#tickets-sidebar').addClass('full');
        $('#sidebar-full').show();
        $.cookie("TicketListParamsCookieSideBar-" + LoggedUserProviderKey, "full", { expires: 365 });
    });

    $("#GreyBoxView").on("click", ".view-favorite-button", function () {
        $.ajax({
            url: RQ_URL + '/View/SetFavoriteView',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: viewId,
                selected: !$(".view-favorite-button").hasClass("active"),
            }),
            success: function (g) {
                if (!$(".view-favorite-button .fa-eye-slash").length > 0) {
                    $(".fa-eye").addClass("fa-eye-slash");
                    $(".fa-eye").removeClass("fa-eye");
                } else {
                    $(".fa-eye-slash").addClass("fa-eye");
                    $(".fa-eye-slash").removeClass("fa-eye-slash");
                }
                reloadViewGroups();
            },
        });
    });

    $("#GreyBoxView").on("click", ".view-desktop-button", function () {
        $.ajax({
            url: RQ_URL + '/View/SetDesktopView',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: viewId,
                select: !$(".view-desktop-button").hasClass("active"),
            }),
            success: function (g) {
            },
        });
    });

    $("#dialog-Manage-Views").on("click", ".view-desktop-button", function () {
        refreshAfterCloseViewManager = true;
        $.ajax({
            url: RQ_URL + '/View/SetDesktopView',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $(this).data("id"),
                select: !$(this).hasClass("active"),
            }),
            success: function (g) {
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
            },
        });
    });

    $("#dialog-Manage-Views").on("click", ".view-favorite-button", function () {
        refreshAfterCloseViewManager = true;
        var $e = $(this);
        $.ajax({
            url: RQ_URL + '/View/SetFavoriteView',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $(this).data("id"),
                selected: !$e.hasClass("active"),
            }),
            success: function (g) {
                if (!$e.find(".fa-eye").length > 0) {
                    $e.find(".fa-eye-slash").addClass("fa-eye");
                    $e.find(".fa-eye-slash").removeClass("fa-eye-slash");
                } else {
                    $e.find(".fa-eye").addClass("fa-eye-slash");
                    $e.find(".fa-eye").removeClass("fa-eye");
                }
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
            },
        });
    });

    $("#dialog-Manage-Views").on("click", ".js-view-group-favorite-button", function () {
        refreshAfterCloseViewManager = true;
        var $e = $(this);
        $.ajax({
            url: RQ_URL + '/View/SetFavoriteViewGroup',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $(this).data("id"),
                selected: !$e.hasClass("active"),
            }),
            success: function (g) {
                if (!$e.find(".fa-eye").length > 0) {
                    $e.find(".fa-eye-slash").addClass("fa-eye");
                    $e.find(".fa-eye-slash").removeClass("fa-eye-slash");

                } else {
                    $e.find(".fa-eye").addClass("fa-eye-slash");
                    $e.find(".fa-eye").removeClass("fa-eye");
                }
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
            },
        });
    });

    $("body").on("click", ".js-view-group > .js-view-group-title .js-name, .js-view-group > .js-view-group-title .fa-chevron-right, .js-view-group > .js-view-group-title .fa-chevron-down", function () {
        $group = $(this).closest(".js-view-group");
        $title = $group.find(".js-view-group-title");
        if ($title.data("open") == "True") {
            $group.find(".views").hide();
            $group.find(".views-drop").show();
            $title.data("open", "False");
            $chevronDown = $group.find(".fa-chevron-down");
            $chevronDown.removeClass("fa-chevron-down");
            $chevronDown.addClass("fa-chevron-right");
        } else {
            $group.find(".views").show();
            $group.find(".views-drop").hide();
            $title.data("open", "True");
            $chevronRight = $group.find(".fa-chevron-right");
            $chevronRight.removeClass("fa-chevron-right");
            $chevronRight.addClass("fa-chevron-down");
            if ($group.data("isloaded") == "False") {
                //otevřel jsem skupinu načtu sumace
                var count = $group.find('li.personal-view').length;

                $group.data("isloaded", "True");//aby se příště načítali data jen z cache a nepočítalo se to 
                //each je paralerní
                $group.find('li.personal-view').each(function () {
                    myViewsWaitingToLoadCount.push($(this).data('id'));
                    if (!--count) {
                        loadTicketsCountFromArray();
                    }
                });
            }
        }
        $.ajax({
            url: RQ_URL + '/View/SetViewGroupOpen',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $group.data("id"),
                open: $title.data("open") == "True",
            })
        });
    });

    $("#BaseTicketSet").select2({
        minimumResultsForSearch: Infinity,
        dropdownAutoWidth: 'true'
    }).on("change", function (e) {
        if (reloadTicketBaseTicketSet) {
            sendViewId = false;
            loadPage = false;
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
        }
        else {
            reloadTicketBaseTicketSet = true;
        }
    });

    $('#formViewRulesValidationOnly').validate({
        rules: {
            ourTime: true
        }
    });

    $('#formViewRulesValidationOnly').validate();


    $("#dialog-New-View").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                saveViewAs();
            }
        }, {
            text: Localization_Close,
            click: function () {
                cancelDialog();
            }
        }]
    });

    $("#dialog-Delete-View").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/View/DeleteView?id=' + deleteId,
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                }).done(function (data) {
                    if (viewId == deleteId) {
                        viewId = -1;
                    }

                    if (refreshManageTable) {
                        refreshAfterCloseViewManager = true;
                        reloadManageViewShowDivForLoading = true;
                        reloadManageViewsTable();
                    }
                    else {
                        reloadViewGroups();
                        selectAll();
                    }
                });
                $("#dialog-Delete-View").dialog("close");
            }
        }, {
            text: Localization_No,
            click: function () {
                $("#dialog-Delete-View").dialog("close");
            }
        }]
    });

    $("#dialog-Delete-View-Group").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/View/DeleteViewGroup?id=' + deleteGroupId,
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                }).done(function (data) {
                    if (refreshManageTable) {
                        refreshAfterCloseViewManager = true;
                        reloadManageViewShowDivForLoading = true;
                        reloadManageViewsTable();
                    }
                    else {
                        reloadViewGroups();
                        selectAll();
                    }
                });
                $("#dialog-Delete-View-Group").dialog("close");
            }
        }, {
            text: Localization_No,
            click: function () {
                $("#dialog-Delete-View-Group").dialog("close");
            }
        }]
    });

    $("#dialog-Share-View-Group").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        open: function () {
            //OnAjaxBegin(Localization_LoadingInformationAboutView);
            $("#dialog-Share-View-Group").html("<div class='loading-32'></div>");
            $(this).load(RQ_URL + '/View/PartialDialogShareViewGroup?id=' + dialogId, function () {
                $.ajax({
                    url: RQ_URL + '/View/GetViewGroupShareSettings?id=' + dialogId,
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                }).done(function (data) {
                    $("#ShareViewGroupId").val(dialogId);
                    $("#dialog-Share-View-Group").find("input[value='" + data.Type + "']").attr('checked', true).trigger("change");
                    if (data.Type == 5) {
                        $("#dialogShareViewSelects").show();
                    }
                    else {
                        $("#dialogShareViewSelects").hide();
                    }
                    $("#InternalGroups").val(data.InternalGroups).trigger("change");
                    $("#OperatorGroups").val(data.OperatorGroups).trigger("change");
                    $("#CustomerGroups").val(data.CustomerGroups).trigger("change");
                    $("#Customers").val(data.Customers).trigger("change");
                    $("#Users").val(data.Users).trigger("change");
                    $("#ShareDialogAdministratorsCanEdit").prop("checked", data.AdministratorsCanEdit);
                    $("#ShareDialogShowOnDesktopDefaultValue").prop("checked", data.ShowOnDesktopDefault);
                    //OnAjaxComplete();
                })
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
            });
        },
        buttons: [{
            text: Localization_Save,
            click: function () {
                refreshAfterCloseViewManager = true;
                saveShareSettings();
            }
        },
        {
            text: Localization_Close,
            click: function () {
                cancelShareViewGroupDialog();
            }
        }]
    });

    $("#dialog-Settings-View").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                refreshAfterCloseViewManager = true;
                saveSettings();
            }
        },
        {
            text: Localization_Close,
            click: function () {
                cancelRenameDialog();
            }
        }
        ]
    });

    $("#dialog-Manage-Views").dialog({
        autoOpen: false,
        resizable: false,
        width: 800,
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Close,
            click: function () {
                managerVisibleTable = false;
                $("#dialog-Manage-Views").dialog("close");
            },
        }],
        close: function () {
            if (refreshAfterCloseViewManager) {
                reloadViewGroups();
                if (viewId == -1) {
                    selectAll();
                }
                else {
                    selectView(viewId);
                }
            }
        }
    });

    $("#dialog-Group").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                saveGroup();
            }
        },
        {
            text: Localization_Close,
            click: function () {
                $("#dialog-Group").dialog("close");
            }
        }
        ]
    });

    $("#dialog-Tickets-Bulk-Actions").dialog({
        autoOpen: false,
        resizable: false,
        width: "800",
        height: "auto",
        modal: true,
        close: function (event, ui) {
            if (reloadTheTickets) {
                window.location = RQ_URL + '/Tickets/List';
                reloadTheTickets = false;
            }
        },
        buttons: [{
            id: "BulkActionsPerform",
            text: Localization_Perform,
            click: function () {
                closeBulkDialog = false;
                reloadTheTickets = true;
                bulkActionValidForm();
            }
        }, {
            id: "BulkActionsPerformAndClose",
            text: Localization_PerformAndClose,
            click: function () {
                closeBulkDialog = true;
                bulkActionValidForm();
            }
            }, {
            id: "BulkActionsClose",
            text: Localization_Close,
            click: function () {
                $("#dialog-Tickets-Bulk-Actions").dialog("close");
            }
        }]
    });

    $("#dialog-Tickets-Bulk-Actions-Tickets").dialog({
        autoOpen: false,
        resizable: false,
        width: "800",
        height: "auto",
        modal: true,
        close: function (event, ui) {
            if (closeBulkDialog) {
                $("#dialog-Tickets-Bulk-Actions").dialog("close");
            }
        },
        buttons: [{
            text: Localization_Close,
            click: function () {
                $("#dialog-Tickets-Bulk-Actions-Tickets").dialog("close");
            }
        }]
    });


    $("#DialogViewName").change(function () {
        $("DialogViewNameErrorMessage").hide();
    });

    var columnTypeValue = -1;

    $("#dialog-Share-View-Group").on("change", "input:radio", function () {
        if ($(this).val() == 5) {
            $(".js-for-others").show();
        }
        else {
            $(".js-for-others").hide();
        }
    });

    $("body").on("change", "#ConditionsForView .condition-for-view .column-type:not(.select2-container)", function () {
        sendViewId = false;
        loadPage = false;
        setSaveButtonsForEdit((columnTypeValue != -1));
        ruleFieldChanged($(this).closest(".condition-for-view").attr("data-id"));
    });

    $("body").on("focus", "#ConditionsForView .condition-for-view .column-type:not(.select2-container)", function () {
        columnTypeValue = $(this).val();
    });

    $("body").on("change", "#ConditionsForView .condition-for-view .column-operators", function () {
        sendViewId = false;
        loadPage = false;
        var valid = true;
        if ($(this).closest(".condition-for-view").children(".value").hasClass("select2-for-views")) {
            if ($(this).closest(".condition-for-view").children(".value").val() == undefined) {
                valid = false;
            }
        }
        else {
            if ($(this).closest(".condition-for-view").children(".value").val() == null && $(this).closest(".condition-for-view").children(".ui-spinner").children(".value").val() == null) {
                valid = false;
            }
        }

        setSaveButtonsForEdit(valid);
        if (valid) {
            showDataIfRulesAreAlrightTimer();
        }
    });

    $("body").on("change", "#ConditionsForView .relationship", function () {
        sendViewId = false;
        loadPage = false;
        setSaveButtonsForEdit($(this).parent().children(".column-type:not(.select2-container)").val() != -1);
        SetPage(1);
        showDataIfRulesAreAlrightTimer();
    });

    $("body").on("change", "#ConditionsForView .time", function () {
        sendViewId = false;
        loadPage = false;
        setSaveButtonsForEdit(false);
        showDataIfRulesAreAlrightTimer();
    });

    $("body").on("change", "#ConditionsForView .text", function () {
        sendViewId = false;
        loadPage = false;
        setSaveButtonsForEdit(false);
        showDataIfRulesAreAlrightTimer();
    });

    $("body").on("click", "#ConditionsForView .condition-for-view .delete-button", function () {
        sendViewId = false;
        loadPage = false;
        setSaveButtonsForEdit(false);
        deleteRule($(this).closest(".condition-for-view").attr("data-id"));
        showDataIfRulesAreAlrightTimer();
        if ($("#ConditionsForView .condition-for-view").length == 0) {
            $("#AddButtonAfterDeleteAllRules").show();
        }
    });

    $("body").on("click", "#ConditionsForView .condition-for-view .add-button", function () {
        sendViewId = false;
        loadPage = false;
        addNewFiltr();
    });



    //pri zmene velikosti stranky post
    $('#ticketsDiv').on("change", '#ddlPageSize', function () {
        SetPage(1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#tickets-nav-previous", function () {
        $("#hiddenCurrentPage").val(currentPage - 1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#page-previousPages", function () {
        $("#hiddenCurrentPage").val(startPage - 1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#page-nextPages", function () {
        $("#hiddenCurrentPage").val(endPage + 1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#tickets-nav-next", function () {
        $("#hiddenCurrentPage").val(currentPage + 1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#tickets-nav-last", function () {
        $("#hiddenCurrentPage").val(numberOfPages);
        submitFormList();
    });

    $("#formViewRulesValidationOnly").on("keypress", "input", function (event) {
        if (event.which == 13 && !event.shiftKey) {
            event.preventDefault();
            $(this).trigger("change");
        }
    });

    //pri zmene razeni post 
    $('#ticketsDiv').on("click", ".aSortBy", function () {
        var newSortBy = $(this).data('sort-by');
        var oldSortBy = $('#hiddenSortBy').val();
        var oldSortByDesc = $('#hiddenSortByDesc').val();

        if (newSortBy == oldSortBy) {
            $('#hiddenSortByDesc').val(oldSortByDesc == 'True' ? 'False' : 'True'); //js returns in lowercase
        }
        else {
            $('#hiddenSortBy').val(newSortBy);
        }

        SetPage(1);
        submitFormList();
    });

    //print vyberu stranky - ulozeni do hiddenfield alert post
    $('#ticketsDiv').on("click", "a.page-number", function () {
        var page = parseInt($(this).text());
        SetPage(page);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#tickets-nav-first", function () {
        SetPage(1);
        submitFormList();
    });

    $('#ticketsDiv').on("click", "#filter-reset", function () {
        $("#hiddenTicketTypeValue").val("-1");
        $('#ddlServiceTreeCombo').val("s:all");
        $('#ddlServiceListCombo').val("s:all");
        $('#ddlDepartmentTreeCombo').val("s:all");
        $('#ddlCombinedDepartmentTreeCombo').val("s:all");
        $('#ddlCombinedServiceListCombo').val("s:all");
        $('#ddlCustomerCombo').val("all");
        $('#ddlSubmitterCombo').val("**all**");
        $('#ddlSolverCombo').val("**all**");
        SetPage(1);
        submitFormList();
    });

    $('#tickets-main').on("click", ".image-export[data-format]", function () {
        var format = $(this).data("format");
        makeModel();
        $.ajax({
            type: 'POST',
            url: RQ_URL + '/Tickets/Export',
            data: $('#ticketsForm').serialize(),
            success: function () {
                window.location = RQ_URL + '/Tickets/Export/' + format;
            },
            error: function (error) { alert(error.responseText); }
        });
    });


    $('#ticketsDiv').on("change", '.ticket-checkbox', function () {
        SelectTicketCheckbox($(this));
    });

    $('#ticketsDiv').on("change", '#ticket-checkbox-all', function () {
        var checked = $(this).is(':checked');

        $('#tickets-table tbody tr .ticket-checkbox').each(function () {
            $(this).prop('checked', checked);
            SelectTicketCheckbox($(this));
        });
    });

    $('#tickets-main').on("click", '.merge-tickets', function () {
        OpenMergeTicketsDialog(ticketIdsArray);
    });

    $('#tickets-main').on("click", '.change-submitter', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenChangeSubmitterDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.change-solver', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenChangeSolverDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.change-service', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenChangeServiceDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.take-from-queue', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenTakeFromQueueDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.assign-solver', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenAssignSolverDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.close-tickets', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenCloseTicketsDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.delete-tickets', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenDeleteTicketsDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.archive:not([disabled])', function () {
        if (!$(this).is(':disabled') && checkSomeTicketsAreSelected()) {
            OpenArchiveTicketsDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.unarchive:not([disabled])', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenUnarchiveTicketsDialog(ticketIdsArray);
        }
    });

    $('#tickets-main').on("click", '.markSpam:not([disabled])', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenSpamTicketsDialog(ticketIdsArray, true);
        }
    });

    $('#tickets-main').on("click", '.notSpam:not([disabled])', function () {
        if (checkSomeTicketsAreSelected()) {
            OpenSpamTicketsDialog(ticketIdsArray, false);
        }
    });

    $('#tickets-main').on("click", '.tickets-bulk-actions:not([disabled])', function () {
        openTicketsBulkActions();
    });

    $("body").on("change", "#TicketsBulkActions", function () {
        $("#TicketsBulkActionsContent").html("<div class='loading-32'></div>");
        $("#TicketsBulkActionsContent").load(RQ_URL + "/Tickets/LoadBulkActionContent/" + $(this).val(), function () {
            $("#TicketIds").val(ticketIdsArray);
        });
    });

    var idTicketGlobal = -1;
    var idTicketGlobalFirstMessage = -1;
    var idTicketRelation = -1;

    var showLoading;
    var showLoadingFirstMessage;
    var showLoadingRelation;

    $("body").on('mouseover', 'span.messagesCount', function () {
        clearTimeout(repeatTimer);
        clearTimeout(showLoading);
        var messageCount = $(this);
        var idTicket = $(this).data('ticketid');
        idTicketGlobal = idTicket;
        repeatTimer = setTimeout(function () {
            clearTimeout(repeatTimer);
            showLoading = setTimeout(function () {
                clearTimeout(showLoading);
                if (idTicketGlobal == idTicket) {
                    messageCount.popover({
                        content: '<div class="loading-32"></div>',
                        placement: 'auto',
                        html: true,
                    });
                    messageCount.popover('show');
                }
            }, 500);
            $.post(
                RQ_URL + "/Tickets/LastAnswer",
                {
                    id: idTicket,
                },
                function (data) {
                    if (messageCount != null && idTicketGlobal == idTicket) {
                        idTicketGlobal = -1;
                        messageCount.popover('destroy');
                        messageCount.popover({
                            content: "<div class='tooltipDetail'><div><span>" + Localization_LastAnswer + ":</span><pre>" + data.Text + "</pre></div></div>",
                            placement: 'auto',
                            html: true,
                        });
                        messageCount.popover('show');
                    }
                },
                "json"
            )
            .fail(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
        }, 150);
    });

    $("body").on('mouseout', 'span.messagesCount', function () {
        idTicketGlobal = -1;
        var messageCount = $(this);
        if (messageCount != null) {
            messageCount.popover('destroy');
        }
        clearTimeout(repeatTimer);
    });


    $("body").on('mouseover', 'span.stickyNotesCount', function () {
        clearTimeout(repeatTimer);
        clearTimeout(showLoading);
        var $stickyNoteCount = $(this);
        var idTicket = $(this).data('ticketid');
        idTicketGlobal = idTicket;
        repeatTimer = setTimeout(function () {
            clearTimeout(repeatTimer);
            showLoading = setTimeout(function () {
                clearTimeout(showLoading);
                if (idTicketGlobal == idTicket) {
                    $stickyNoteCount.popover({
                        content: '<div class="loading-32"></div>',
                        placement: 'auto',
                        html: true,
                    });
                    $stickyNoteCount.popover('show');
                }
            }, 500);
            $.post(
                RQ_URL + "/Tickets/LastTicketStickyNote",
                {
                    id: idTicket,
                },
                function (data) {
                    if ($stickyNoteCount != null && idTicketGlobal == idTicket) {
                        idTicketGlobal = -1;
                        $stickyNoteCount.popover('destroy');
                        if (data != null) {
                            $stickyNoteCount.popover({
                                content: "<div class='tooltipDetail'><div><span>Poslední poznámka:</span><pre>" + data + "</pre></div></div>",
                                placement: 'auto',
                                html: true,
                            });
                            $stickyNoteCount.popover('show');
                        }
                        else {
                            $stickyNoteCount.remove();
                        }
                    }
                },
                "json"
            )
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
        }, 150);
    });

    $("body").on('mouseout', 'span.stickyNotesCount', function () {
        idTicketGlobal = -1;
        var stickyNoteCount = $(this);
        if (stickyNoteCount != null) {
            stickyNoteCount.popover('destroy');
        }
        clearTimeout(repeatTimer);
    });

    $("body").on('click', 'span.relatedTicketsCount', function (e) {
        clearTimeout(repeatRateTimer);
        var relatedTickets = $(this);
        relatedTickets2 = relatedTickets;
        var idTicket = $(this).data('ticketid');
        idTicketRelation = idTicket;
        repeatRateTimer = setTimeout(function () {
            clearTimeout(repeatRateTimer);
            if (idTicketRelation == idTicket) {
                relatedTickets.popover({
                    content: '<div class="loading-32"></div>',
                    placement: 'auto',
                    html: true,
                    animation: false,
                });
                relatedTickets.popover('show');
            }

            $.post(
                RQ_URL + "/Tickets/LoadTicketRelations",
                {
                    id: idTicket,
                },
                function (data) {
                    if (idTicketRelation == idTicket) {
                        idTicketRelation = -1;
                        relatedTickets.popover('toggle');
                        relatedTickets.popover('destroy');
                        relatedTickets.popover({
                            content: data,
                            placement: 'auto',
                            html: true,
                            animation: false,
                        });
                        relatedTickets.popover('toggle');
                        relatedTickets.popover('show');
                    }
                },
                "html"
            )
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
        }, 250);
    });

    $('body').on('click', function (e) { //to close popover when clicked outside
        $("span.relatedTicketsCount").each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('destroy');
            }
        });
    });

    var repeatTimer;
    var repeatRateTimer;

    $("body").on('mouseover', 'a.ticket-subject', function () {
        clearTimeout(repeatRateTimer);
        clearTimeout(showLoadingFirstMessage);
        var subject = $(this);
        var idTicket = $(this).data('ticketid');
        idTicketGlobalFirstMessage = idTicket;
        repeatRateTimer = setTimeout(function () {
            clearTimeout(repeatRateTimer);

            showLoadingFirstMessage = setTimeout(function () {
                clearTimeout(showLoadingFirstMessage);
                if (idTicketGlobalFirstMessage == idTicket) {
                    subject.popover({
                        content: '<div class="loading-32"></div>',
                        placement: 'auto',
                        html: true,
                    });
                    subject.popover('show');
                }
            }, 500);

            $.post(
                RQ_URL + "/Tickets/TicketFirstMessage",
                {
                    id: idTicket,
                },
                function (data) {
                    if (subject != null && idTicketGlobalFirstMessage == idTicket) {
                        idTicketGlobalFirstMessage = -1;
                        subject.popover('destroy');
                        subject.popover({
                            content: "<div class='tooltipDetail'><div> <span>" + Localization_Service + ":</span>" + htmlEncode(data.Service) + "</div><div><span>" +
                                Localization_Operator + ":</span>" + htmlEncode(data.Solver) + "</div><div><span>" +
                                Localization_ReportedBy + ":</span>" + htmlEncode(data.Submitter) + "</div><div><span>" +
                                Localization_Subject + ":</span>" + htmlEncode(data.Subject) + "</div><div><span>" +
                                Localization_Text + ":</span><pre>" + htmlEncode(data.Message) + "</pre></div></div>",
                            placement: 'auto',
                            html: true,
                        });
                        subject.popover('show');
                    }
                },
                "json"
            )
                .fail(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
        }, 250);
    });

    $("body").on('click', 'a.ticket-subject', function () {
        idTicketGlobalFirstMessage = -1;
        var subject = $(this);
        if (subject != null) {
            subject.popover('destroy');
        }
        clearTimeout(repeatRateTimer);
        subject = null;

        cancelLoadingViewsCount();
    });

    $("body").on('mouseout', 'a.ticket-subject', function () {
        idTicketGlobalFirstMessage = -1;
        var subject = $(this);
        if (subject != null) {
            subject.popover('destroy');
        }
        clearTimeout(repeatRateTimer);
        subject = null;
    });

    $("#dialog-no-tickets-selected").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: {
            OK: function () {
                $(this).dialog('close');
            }
        }
    });

    $('#GreyBoxView .filter-conditions-toggle-icon').click(function () {
        $('#GreyBoxView .filter-conditions-toggle-icon').toggle();
        $('#ConditionsForView').slideToggle();

        setRulesVisibility();
    });

    $('div#affected-tickets-info .fa-stack').click(function () {
        $(this).next('.tickets-list').toggle();
    });


    $('#views-refresh').click(function () {
        reloadViewGroups();
    });

    $("#dialog-Group,#dialog-New-View,#dialog-Settings-View").on("click", ".color-small-box", function () {
        var $element = $(this).closest(".form-group").find(".colorSelector-input");
        $element.val($(this).data("color"));
        $element.trigger("change");
    });

    initPersonalViewsSortable();
});//end document ready

var managerVisibleTable = false;
var reloadTicketBaseTicketSet = true;
var refreshAfterCloseViewManager = false;
var refreshRotationTimeout;
var refreshRotationGlobalTimeout;
var refreshRotationGlobalTimeoutRunning = false;

function AnimateRotate($elem, angle, repeat) {
    var duration = 1000;

    $({ deg: 0 }).animate({ deg: angle }, {
        duration: duration,
        step: function (now) {
            $elem.css({
                'transform': 'rotate(' + now + 'deg)'
            });
        }
    });

    refreshRotationTimeout = setTimeout(function () {
        if (repeat && repeat == "infinite") {
            AnimateRotate($elem, angle, repeat);
        } else if (repeat && repeat > 1) {
            AnimateRotate($elem, angle, repeat - 1);
        }
    }, duration)
}

function AnimateRotateGlobalRefreshButton($elem, angle, repeat) {
    var duration = 1000;

    $({ deg: 0 }).animate({ deg: angle }, {
        duration: duration,
        step: function (now) {
            $elem.css({
                'transform': 'rotate(' + now + 'deg)'
            });
        }
    });

    refreshRotationGlobalTimeout = setTimeout(function () {
        if (repeat && repeat == "infinite") {
            AnimateRotateGlobalRefreshButton($elem, angle, repeat);
        } else if (repeat && repeat > 1) {
            AnimateRotateGlobalRefreshButton($elem, angle, repeat - 1);
        }
    }, duration)
}

function setRulesVisibility() {
    $.ajax({
        url: RQ_URL + '/View/SetVisibilityRules',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            id: viewId,
            rulesVisibility: $("#ViewUpIcon").css("display") != 'none',
        }),
        success: function (g) {
        },
    });
}

function createTree(name, children) {
    for (var i = 0; i < children.length; i++) {
        addItemsToForm(name + ".Children[" + i + "]", children[i]);
        if (children[i].Children.length > 0) {
            createTree(name + ".Children[" + i + "]", children[i].Children);
        }
    }
}

function addItemsToForm(name, data) {
    $("#SendData").append("<input type='hidden' name='" + name + ".AndOrOr' value='" + data.AndOrOr + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".RuleId' value='" + data.RuleId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".CustomFieldId' value='" + data.CustomFieldId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".CustomFormFieldId' value='" + data.CustomFormFieldId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".SlaId' value='" + data.SlaId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".PriorityId' value='" + data.PriorityId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".CategoryId' value='" + data.CategoryId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".PortalId' value='" + data.PortalId + "' />");
    $("#SendData").append("<input type='hidden' name='" + name + ".Operator' value='" + data.Operator + "' />");
    if (data.Values != null) {
        for (var v = 0; v < data.Values.length; v++) {
            $("#SendData").append("<input type='hidden' name='" + name + ".Values[" + v + "]' value='" + data.Values[v] + "' />");
        }
    }
}

var ticketIdsArray = []; //save selected tickets

function checkSomeTicketsAreSelected() {
    if (ticketIdsArray != null && ticketIdsArray.length > 0)
        return true;
    else {
        $("#dialog-no-tickets-selected").dialog('open');
        return false;
    }
}

function setSaveButtonsForEdit(validForm) {
    editView = true;
    if (!newView) {
        //$("#SaveAsView").hide();
        $("#ButtonAfterSomethingChange").show();
        $("#SaveView").hide();
    }
    if (validForm) {
        validateRules();
    }
}

function SelectTicketCheckbox($checkbox) {
    var $tr = $checkbox.closest('tr');
    var ticketId = $tr.data('ticketId');

    var found = jQuery.inArray(ticketId, ticketIdsArray);

    if ($checkbox.is(':checked')) {

        if (found < 0) { // Element was not found, add it.
            ticketIdsArray.push(ticketId);
        }

        $tr.addClass('selected');
    }
    else {
        if (found >= 0) { // Element was found, remove it.
            ticketIdsArray.splice(found, 1);
        }

        $tr.removeClass('selected');
    }

    RefreshTicketCheckboxAllCount();
};

function RefreshTicketCheckboxAllCount() {
    $('#tbTicketCheckboxAll').text(ticketIdsArray.length > 0 ? "(" + ticketIdsArray.length + ")" : "");
    $('#tickets-table-toolbar > .left button[type="button"]').prop('disabled', ticketIdsArray.length == 0);
}


var divsSlaSingle = [];
var divsSlaAll = [];

function OnAjaxSuccess_LoadTickets() {
    //select rows from saved tickets array

    if (ticketIdsArray.length > 0) {
        $('#tickets-table tbody tr').each(function () {
            var ticketId = $(this).data('ticketId');

            var found = jQuery.inArray(ticketId, ticketIdsArray);

            if (found >= 0) {
                $(this).find('.ticket-checkbox').prop('checked', true)
                $(this).addClass('selected');
            }
        });

        RefreshTicketCheckboxAllCount();

        //check check-all if all on the page is checked
        if ($('#tickets-table tbody tr .ticket-checkbox').length == $('#tickets-table tbody tr .ticket-checkbox:checked').length) {
            $('#ticket-checkbox-all').prop('checked', true);
        }
    }

    divsSlaSingle = []; //clear
    divsSlaAll = []; //clear

    $('div.sla-single.refresh').map(function () {
        divsSlaSingle.push($(this));
    });

    $('div.sla-all').map(function () {
        divsSlaAll.push($(this));
    });

    LoadSlaSingle();
    LoadSlaAll();
}

function LoadSlaSingle() {
    if (divsSlaSingle.length > 0) {
        var divSlaSingle = divsSlaSingle[0];
        var ticketId = $(divSlaSingle).closest("tr").data('ticketId');
        var slaId = $(divSlaSingle).data('slaId');

        $.ajax({
            url: RQ_URL + '/Tickets/PartialSlaSingle?ticketId=' + ticketId + '&slaId=' + slaId,
            type: "GET",
            dataType: "html",
            contentType: "application/json; charset=utf-8",
        }).done(function (data) {
            $(divSlaSingle).html(data);
            divsSlaSingle.shift(); //remove first
            LoadSlaSingle(); //recursion
        }).fail(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });
    }
}

function LoadSlaAll() {
    if (divsSlaAll.length > 0) {
        var divSlaAll = divsSlaAll[0];
        var ticketId = $(divSlaAll).closest("tr").data('ticketId');

        $.ajax({
            url: RQ_URL + '/Tickets/PartialSlaAll/' + ticketId,
            type: "GET",
            dataType: "html",
            contentType: "application/json; charset=utf-8",
        }).done(function (data) {
            $(divSlaAll).html(data);
            $(divSlaAll).show();
            divsSlaAll.shift(); //remove first
            LoadSlaAll(); //recursion
        }).fail(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });
    }
}

function SetPage(page) {
    $("#hiddenCurrentPage").val(page);
}

function createNewView(viewGroupId) {
    viewId = -1;
    newViewGroupId = viewGroupId;
    newView = true;
    loadPage = false;
    $("#SelectedDataSource").val(VIEW);
    $("#ConditionsForView").show();
    $("#DialogViewName").val("");
    //$("#SaveAsView").hide();
    $("#ButtonAfterSomethingChange").hide();
    $("#buttonsFavouriteAndDesktop").hide();
    $("#ManagerButton").hide();
    $("#SaveView").show();
    $(".personal-view").removeClass("selected");
    $("#ViewNameEdit").hide();
    $("#ViewNameButton").hide();
    $("#ViewLoading").hide();
    $(".filter-conditions-toggle-icon").hide();
    $("#ViewBaseTicketSet").show();
    $("#BaseTicketSet").val(DEFAULTBASETICKETSET).trigger("change");
    $("#ViewUpIcon").show();
    $("#ViewName").show();
    $("#ViewName").text(Localization_NewView);
    $("#ViewId").val("-1");
    $("#GreyBoxView").show();
    $("#ConditionsForView").empty();
    removeDraft();
    $("#tickets-table tbody").hide();
    hideLoadingIconAndInformationAboutLoadedTickets();

    addNewFiltr();
}

function addNewFiltr() {
    $("#AddButtonAfterDeleteAllRules").hide();
    clearTimeoutForSendData();
    setSaveButtonsForEdit(false);
    var validate = $("#formViewRulesValidationOnly").validate();
    $("#ConditionsForView").append($("#NewRowForCondition").html());

    $.ajax({
        url: RQ_URL + "/View/GetRuleFieldValuesForSelect2",
        context: document.body,
        async: false
    }).done(function (data) {
        var options = createOptionsForColumnType(data);
        reloadTree();
        $("#ConditionsForView").find(".column-type").last().append(options);
        $("#ConditionsForView").find(".column-type").last().select2({ dropdownAutoWidth: true }); //reinit sirky (kvuli options)
        $("#ConditionsForView").find(".column-operators").last().hide();
        $("#ConditionsForView").find(".column-type").last().val("-1").trigger("change");
    })
    .fail(function (error) {
        alert(error.responseText);
    });
}

var elementDepth = 0;
var maxPosition = -1;
var newView = false;
var editView = false;
var revert = false;

function reloadTree() {
    $("#ConditionsForView .condition-for-view").each(function (index, element) {
        $(element).find("select.relationship").attr("id", "RL" + index)
        if (index == 0) {
            $(element).children(".condition-selects").children(".relationship").hide();

            if ($(element).children(".condition-selects").children(".relationship").data('select2')) {
                $(element).children(".condition-selects").children(".relationship").select2('destroy');
            }
        }
        else {
            $(element).children(".condition-selects").children(".relationship").css('display', 'inline-block'); //.show() dá display: block

            if ($(element).children(".condition-selects").children(".relationship").data('select2')) {
                $(element).children(".condition-selects").children(".relationship").select2('destroy');
            }

            $(element).children(".condition-selects").children(".relationship").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        }

        $(element).attr("data-id", index);
        $(element).children(".condition-selects").find("select.column-type").attr("id", "CT" + index);
        $(element).children(".condition-selects").find("select.column-operators").attr("id", "OP" + index);
        $(element).children(".value").attr("id", "FSV" + index);
        maxPosition = index;
    });

    $(".condition-for-view").draggable({
        handle: ".handle",
        helper: "original",
        appendTo: "body",
        revert: "invalid",
        cursor: "move",
        zIndex: 10000,
        scroll: true,
        start: function (event, ui) {
            elementDepth = 0;
        },
        stop: function (event, ui) {
            if (!revert) {
                reloadTree();
                setSaveButtonsForEdit(false);
                showDataIfRulesAreAlrightTimer();
            }
        }

    });

    $(".condition-for-view").droppable({
        tolerance: "pointer",
        out: function (event, ui) {
            revert = true;
        },
        over: function (event, ui) {
            revert = false;
        },
        drop: function (event, ui) {
            revert = false;
            actualElementDepth = $(event.target).parents("*").not("body,html").length;
            var dataid = $(event.target).attr("data-id");
            if ($(ui.draggable).attr("data-id") != $(event.target).attr("data-id") && actualElementDepth > elementDepth) {
                var top = ui.offset.top - $(this).offset().top;
                var height = 5;
                if (top >= height) {
                    $(event.target).find(".sub-children:first").append($(ui.draggable));
                }
                else {
                    $(event.target).before($(ui.draggable));
                }
                $(".condition-for-view").css("left", "0px");
                $(".condition-for-view").css("top", "0px");
                reloadTree();
            }
            elementDepth = actualElementDepth;
        }
    });
}

function ruleFieldChanged(position) {
    var options = "";
    var ruleString = $("#CT" + position).val();

    if ($("#CT" + position).closest(".condition-for-view").find("> .time").length > 0) {
        $("#CT" + position).closest(".condition-for-view").find("> .time").rules("remove", "ourTime");
    }

    var id = -1;
    if (ruleString.indexOf(":") != -1) {
        id = ruleString.substr(0, ruleString.indexOf(":"));
    }
    else {
        id = ruleString;
    }
    var ruleId = id;
    var customFieldId = $("#CT" + position + " option:selected").data('customfieldid');
    var customFormFieldId = $("#CT" + position + " option:selected").data('customformfieldid');
    var slaId = $("#CT" + position + " option:selected").data('slaid');
    var priorityId = $("#CT" + position + " option:selected").data('priorityid');
    var categoryId = $("#CT" + position + " option:selected").data('categoryid');
    var portalId = $("#CT" + position + " option:selected").data('portalid');

    if (ruleId == -1) {
        $("#OP" + position).hide();

        if ($("#FSV" + position).data('select2')) {
            $("#FSV" + position).select2('destroy');
        }

        $("#FSV" + position).remove();
    }
    else {
        $.ajax({
            url: RQ_URL + "/View/GetRuleOperatorValues?RuleId=" + ruleId + "&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId,
            context: document.body,
            async: false
        }).done(function (data) {
            $("#OP" + position + " option").remove();
            $(data).each(function () {
                options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
            });
            $("#OP" + position).html(options);
            $("#OP" + position).show();

            $("#OP" + position).select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        });
        options = "";

        $.ajax({
            url: RQ_URL + "/View/GetRuleEnumeratorOrDataType?RuleId=" + ruleId + "&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId + "&slaId=" + slaId + "&priorityId=" + priorityId + "&categoryId=" + categoryId + "&portalId=" + portalId,
            context: document.body,
            async: false
        }).done(function (data) {
            if ($("#FSV" + position).data('select2')) {
                $("#FSV" + position).select2('destroy');
            }

            $("#FSV" + position).remove();
            var operator_ddl = $("#CT" + position).parent();
            setDataToRule(operator_ddl, data, position, position);
        })
        .fail(function (error) {
            alert(error.responseText);
        });
    }
}

function deleteRule(position) {
    $("#CT" + position).closest(".condition-for-view").remove();
    reloadTree();
}

function initSpinnersAndDatePickers() {
    $('.spinner').spinner({
        min: 0, max: 999, stop: function (e, ui) {
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
            sendViewId = false;
        }
    });
    $(".datepickerCanEmpty").change(function () {
        setSaveButtonsForEdit(false);
        showDataIfRulesAreAlrightTimer();
        sendViewId = false;
    }
    );

    $(".datepickerCanEmpty").datepicker({
        onSelect: function () {
            setSaveButtonsForEdit(false);
            sendViewId = false;
            showDataIfRulesAreAlrightTimer();
        }
    });

    if ($(".text").length > 0) {
        $(".text").each(function () {
            var id = $(this).attr("id");
            $("#" + id + "-error").remove();
        })
        $(".text").rules("remove");
    }

    if ($(".time").length > 0) {
        $(".time").rules("add", { ourTime: true });
    }
}

var viewId = -1;

var sendingTimer;
var intervalForTimer = 2000;

function clearTimeoutForSendData() {
    hideLoadingIconAndInformationAboutLoadedTickets();
    clearTimeout(sendingTimer);
}

function showDataIfRulesAreAlrightTimer() {
    if (!loadPage) {
        clearTimeoutForSendData();
        $("#tickets-table tbody").hide();
        $("#TicketsTableLoadingRow").show();
        sendingTimer = setTimeout(showDataIfRulesAreAlright, intervalForTimer);
    }
}

function showDataIfRulesAreAlright() {
    if (validateRules()) {
        if (loadPage) {
            loadPage = false;
        }
        else {
            SetPage(1);
            submitFormList();
        }
    }
    else {
        hideLoadingIconAndInformationAboutLoadedTickets();
    }
}

function hideLoadingIconAndInformationAboutLoadedTickets() {
    $("#TicketsTableLoadingRow").hide();
    $("#tickets-nav").hide();
}

function reloadView() {
    if (viewId == -1) {
        selectAll();
    }
    else {
        selectView(viewId);
    }    
}

function discardChanges() {
    $("#DraftId").val("");
    if (viewId == -1) {
        selectAll();
    }
    else {
        selectView(viewId);
    }   
}

function saveViewAs() {
    if ($("#DialogViewName").val() == "" || $("#DialogViewColor").val() == "") {
        if ($("#DialogViewName").val() == "")
            $("#DialogViewNameErrorMessage").show();
        if ($("#DialogViewColor").val() == "")
            alert("Chyba"); // ta komponenta to neumožnuje ale pro jistotu je kontrola
    }
    else {
        $("#ViewName").text($("#DialogViewName").val());
        $("#dialog-New-View").dialog("close");
        viewId = -1;
        saveView();
        $("#ButtonAfterSomethingChange").hide();
        //$("#SaveAsView").show();
        $("#ManagerButton").show();
        $("#SaveView").show();
    }
}

function cancelShareViewGroupDialog() {
    $("#dialog-Share-View-Group").dialog("close");
}

function cancelDialog() {
    $("#dialog-New-View").dialog("close");
}

var newViewGroupId = null;

function showSaveDialog() {
    if (validateRules()) {
        $("#dialog-Settings-View").html("");
        $("#dialog-New-View").html("<div class='loading-32'></div>");
        $("#dialog-New-View").dialog("open");
        $("#dialog-New-View").load(RQ_URL + "/View/GetNewView?viewGroupId=" + newViewGroupId, function () {

            $(".colorSelector-input").each(function () {
                InitColorPicker($(this));
            });

            SearchableCombos();
            $("#dialog-New-View").dialog("close");//recenter
            $("#dialog-New-View").dialog("open");
        });
    }
}

function saveView() {
    if (validateRules()) {
        positionForSend = 0;
        var arrayForSend = findSubcondition($("#ConditionsForView").children(".condition-for-view"));
        $.ajax({
            url: RQ_URL + '/View/SaveView',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                Id: viewId,
                Name: $("#ViewName").text(),
                Color: $("#DialogViewColor").val(),
                GroupId: $("#DialogViewGroup").val(),
                Rules: arrayForSend,
                BaseTicketSet: $("#BaseTicketSet").val(),
                RulesVisibility: $("#ViewUpIcon").css("display") != 'none',
            }),
            success: function (g) {
                if (g.Result) {
                    if (viewId != -1) {
                        discardChanges();
                    }
                    else { reloadViewGroups(); }

                    viewId = g.Id;
                    $("#ButtonAfterSomethingChange").hide();
                    $("#ManagerButton").show();
                    $("#buttonsFavouriteAndDesktop").show();
                    $("#SaveView").show();
                }
                else {
                    ShowError(Localization_OneOfTheConditionsIsWrong);
                }
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
    }
}

function cloneView(id) {
    $("#cloneViewTable" + id).tooltipBS('hide');
    $.ajax({
        url: RQ_URL + '/View/CloneView',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            Id: id,
        }),
        success: function (g) {
            if (g.Result) {
                refreshAfterCloseViewManager = true;
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
            }
            else {
                ShowError(Localization_YouCanNotCloneTheView);
            }
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function cloneViewGroup(id) {
    $("#cloneViewGroupTable" + id).tooltipBS('hide');
    $.ajax({
        url: RQ_URL + '/View/cloneViewGroup',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            Id: id,
        }),
        success: function (g) {
            if (g.Result) {
                refreshAfterCloseViewManager = true;
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
                reloadViewGroups();
            }
            else {
                ShowError(Localization_YouCanNotCloneTheView);
            }
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function hideViewGroup(id) {
    $.ajax({
        url: RQ_URL + '/View/SetFavoriteViewGroup',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            id: id,
            selected: false,
        }),
        success: function (g) {
            reloadViewGroups();
        },
    });
}

var positionForSend = -1;

function findSubcondition(conditions) {
    var arrayResult = new Array();
    for (var i = 0; i < conditions.length; i++) {
        var andOrOr = $(conditions[i]).children(".condition-selects").find("select.relationship").val();
        var ruleString = $(conditions[i]).children(".condition-selects").find("select.column-type").val();
        var id = -1;
        if (ruleString.indexOf(":") != -1) {
            id = ruleString.substr(0, ruleString.indexOf(":"));
        }
        else {
            id = ruleString;
        }
        var ruleId = id;
        var customFieldId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('customfieldid');
        var customFormFieldId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('customformfieldid');
        var slaId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('slaid');
        var priorityId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('priorityid');
        var categoryId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('categoryid');
        var portalId = $(conditions[i]).children(".condition-selects").find(".column-type:not(.select2-container) option:selected").data('portalid');
        var operator = $(conditions[i]).children(".condition-selects").find(".column-operators").val();
        var values = [];
        if ($(conditions[i]).find("#FSV" + positionForSend).hasClass("select2-for-views")) {
            values = $(conditions[i]).find("#FSV" + positionForSend).val();
        }
        else {
            var value = $(conditions[i]).find("#FSV" + positionForSend).val();
            values.push(value);
        }
        positionForSend++;
        var children = findSubcondition($(conditions[i]).children(".sub-children").children(".condition-for-view"));
        arrayResult.push({ AndOrOr: andOrOr, RuleId: ruleId, CustomFieldId: customFieldId, CustomFormFieldId: customFormFieldId, SlaId: slaId, PriorityId: priorityId, CategoryId: categoryId, PortalId: portalId, Operator: operator, Values: values, Children: children });
    }
    return arrayResult;
}

function validateRules() {
    if (!$("#formViewRulesValidationOnly").valid()) {
        return false;
    }
    $("#ConditionsForView").find(".condition-for-view").children(".valid-error").hide();
    var result = true;
    var columnTypes = $("#ConditionsForView").find(".column-type");
    for (i = 0; i < columnTypes.length; i++) {
        if ($(columnTypes[i]).val() == "-1") {
            result = false;
            $(columnTypes[i]).closest(".condition-for-view").children(".valid-error").show();
        }
    }

    return result;
}

var myViewsWaitingToLoadCount = [];
var originalViewGroup;

function initPersonalViewsSortable() {
    $(".personal-views").sortable({
        handle: ".handle",
        placeholder: "ui-state-highlight",
        connectWith: ".personal-views",
        activate: function (e, ui) {
            $(".views-drop").css("height", ui.item.height());
        },
        start: function (e, ui) {
            originalViewGroup = $(ui.item).closest(".js-view-group");
        }, 
        stop: function (e, ui) {
            //prepocitam pocty pohledu ve skupinach po presunuti pohledu
            var newViewGroup = $(ui.item).closest(".js-view-group");

            if (newViewGroup.data("id") != originalViewGroup.data("id") && (!$(ui.item).hasClass("js-my-view") || !newViewGroup.hasClass("js-my-view-group"))) {
                $(this).sortable('cancel');
                newViewGroup.find('.view-group-title-text .js-count').text(newViewGroup.find('.personal-view').length);
                originalViewGroup.find('.view-group-title-text .js-count').text(originalViewGroup.find('.personal-view').length);
            }
            $(".views-drop").css("height", "0");
        }, 
        update: function (event, ui) {
            if (this === ui.item.parent()[0]) { // https://stackoverflow.com/questions/3492828/jquery-sortable-connectwith-calls-the-update-method-twice?utm_medium=organic&utm_source=google_rich_qa&utm_campaign=google_rich_qa
                var e = $(ui.item).closest('.personal-views');
                var newIndex = $(ui.item).closest('.personal-views').find(".personal-view").index(ui.item);
                var id = $(ui.item).data("id");

                $.ajax({
                    url: RQ_URL + '/View/NewOrder',
                    data: JSON.stringify({ id: id, newPosition: newIndex, viewGroupId: $(ui.item).closest(".js-view-group").data("id") }),
                    type: "POST",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    cache: false,
                });

                //prepocitam pocty pohledu ve skupinach po presunuti pohledu
                var newViewGroup = $(ui.item).closest(".js-view-group");

                if (newViewGroup.data("id") != originalViewGroup.data("id")) {
                    newViewGroup.find('.view-group-title-text .js-count').text(newViewGroup.find('.personal-view').length);
                    originalViewGroup.find('.view-group-title-text .js-count').text(originalViewGroup.find('.personal-view').length);
                }
            }
        }
    });
    $(".view-groups").sortable({
        handle: ".handle",
        items: ".js-can-move",
        update: function (event, ui) {
            var newIndex = $(this).find('.js-view-group').index(ui.item);
            var id = $(ui.item).data("id");
            $.ajax({
                url: RQ_URL + '/View/NewViewGroupOrder',
                data: JSON.stringify({ id: id, newPosition: newIndex }),
                type: "POST",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                cache: false,
            });
        }
    });

    $(".views-drop").droppable({
        hoverClass: 'ui-state-highlight',
        accept: ".personal-view.js-my-view",
        drop: function (event, ui) {
            var id = $(ui.draggable).data("id");
            $(ui.draggable).remove();
            var newIndex = 0;
            var viewGroupId = $(this).closest(".js-view-group").data("id");
            $.ajax({
                url: RQ_URL + '/View/NewOrder',
                data: JSON.stringify({ viewGroupId: viewGroupId, newPosition: newIndex, id: id }),
                type: "POST",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                cache: false,
                success: function (g) {
                    reloadViewsForGroup(viewGroupId);
                },
                error: function (error) {
                    alert(error.responseText);
                },
            });
        }
    });
}

function refreshViewTicketsCount(viewId) {
    myViewsWaitingToLoadCount.push(viewId);
    loadTicketsCountFromArray(true);
}

function loadTicketsCountFromArray(refresh) {
    if (refresh === undefined) { refresh = false; }

    if (myViewsWaitingToLoadCount.length > 0) {

        var id = myViewsWaitingToLoadCount[0];
        var dataSource = id != null ? VIEW : ALL;

        myViewsWaitingToLoadCount.shift();

        $.ajax({
            url: RQ_URL + '/Tickets/LoadCountForView?viewId=' + id + '&dataSource=' + dataSource + '&archived=' + $('#hiddenArchive').val() + '&refresh=' + refresh,
            type: "GET",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            cache: false,
        }).done(function (data) {
            if (!data.error) {
                if (data.viewId == null) {
                    data.viewId = -1;
                }

                var $li = data.viewId == -1 ? $("#AllTickets") : $("#PersonalView" + data.viewId);
                var $lbTicketsCount = $li.find(".tickets-count");

                //var originalCount = $lbTicketsCount.text();

                $li.removeClass('fresh');

                if (data.viewIsComplete) {
                    $lbTicketsCount.text(data.count);
                }
                else {
                    $lbTicketsCount.text("-");
                }

                if (data.fresh) { $li.addClass('fresh'); }
                $li.find('.badge .fas.fa-sync-alt').hide();

                $li.find('.badge').fadeIn();
            }

            loadTicketsCountFromArray(refresh);
        })
        .fail(function (error) {
            if (typeof error.responseText !== 'undefined') { console.log(error.responseText); }
        });
    }
    else {
        refreshRotationGlobalTimeoutRunning = false;
        clearTimeout(refreshRotationGlobalTimeout);
    }
}

function cancelLoadingViewsCount() {
    myViewsWaitingToLoadCount = [];
}

function defaultButtonVisibilityForView() {
    $("#ButtonAfterSomethingChange").hide();
    $("#buttonsFavouriteAndDesktop").hide();
    $("#ManagerButton").hide();
    $("#SaveView").hide();
    $("#GreyBoxView").show();
}

function selectAll() {
    viewId = -1;
    newView = false;
    editView = false;
    removeDraft();
    $("#AddButtonAfterDeleteAllRules").hide();
    $("#SelectedDataSource").val(ALL);
    $(".personal-view").removeClass("selected");
    $(".personal-view .badge .fas.fa-sync-alt").remove();
    $(".personal-view .badge .tickets-count").show();
    $("#AllTickets").addClass("selected");
    $("#AllTickets .badge .tickets-count").hide();
    $("#AllTickets .badge").append('<i class="fas fa-sync-alt"></i>');
    AnimateRotate($("#AllTickets .badge .fas.fa-sync-alt"), 360, "infinite");

    $("#ConditionsForView").empty();
    $("#GreyBoxView").hide();
    SetPage(1);
    submitFormList();
}

function selectView(id) {
    $("#AddButtonAfterDeleteAllRules").hide();
    ticketIdsArray = new Array();
    RefreshTicketCheckboxAllCount();
    $("#dialog-Manage-Views").dialog("close");
    managerVisibleTable = false;
    $("#SelectedDataSource").val(VIEW);
    newView = false;
    editView = false;
    sendViewId = true;
    viewId = id;
    defaultButtonVisibilityForView();
    $("#ConditionsForView").empty();
    $(".filter-conditions-toggle-icon").hide();
    $("#ViewBaseTicketSet").hide();
    $("#ViewUpIcon").hide();
    $("#ViewName").text($("#PersonalView" + id).find(".view-name > span").html());
    $("#ViewLoading").show();
    $(".personal-view").removeClass("selected");
    $(".personal-view .badge .fas.fa-sync-alt").remove();
    $(".personal-view .badge .tickets-count").show();

    if (id != -1) {
        $("#PersonalView" + id).addClass("selected");
        $("#PersonalView" + id + " .tickets-count").hide();
        $("#PersonalView" + id + " .badge").append('<i class="fas fa-sync-alt"></i>');
        AnimateRotate($("#PersonalView" + id + " .badge .fas.fa-sync-alt"), 360, "infinite");

        //OnAjaxBegin("Načítám pohled...");
        $.ajax({
            url: RQ_URL + '/View/GetView?id=' + id + '&draftId=' + $("#DraftId").val(),
            type: "GET",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            cache: false,
        }).done(function (data) {
            if (data == null) {
                //pohled byl smazán jiným adminem
                selectAll();
                reloadViewGroups();
            }
            else {
                if (data.Id == viewId) {
                    $("#ViewId").val(data.Id);
                    $("#ViewName").text(data.Name);
                    $(".view-favorite-button").removeClass("active");
                    if (data.Favorite) {
                        $(".view-favorite-button").addClass("active");
                        $(".view-favorite-button").find(".fa-eye-slash").addClass("fa-eye");
                        $(".view-favorite-button").find(".fa-eye-slash").removeClass("fa-eye-slash");
                    } else {
                        $(".view-favorite-button").find(".fa-eye").addClass("fa-eye-slash");
                        $(".view-favorite-button").find(".fa-eye").removeClass("fa-eye");
                    }
                    $(".view-desktop-button").removeClass("active");
                    if (data.ShowOnDesktop) {
                        $(".view-desktop-button").addClass("active");
                    }
                    $("#ConditionsForView").empty();
                    if (!data.CanEdit) {
                        $("#ConditionsForView").hide();
                        var div = $("#ViewName").parent();
                        $(div).children().hide();
                        $("#ViewName").show();
                        $("#buttonsFavouriteAndDesktop").show();
                    }
                    else {
                        if ($("#BaseTicketSet").length > 0) {
                            reloadTicketBaseTicketSet = false;
                            $("#BaseTicketSet").val(data.BaseTicketSet).trigger("change");
                        }
                        defaultButtonVisibilityForView();
                        $("#ConditionsForView").show();
                        var div = $("#ViewName").parent();
                        $(div).children().hide();
                        $("#ViewBaseTicketSet").show();
                        $("#ManagerButton").show();
                        if ($("#DraftId").val() == "") {
                            $("#SaveView").show();
                        }
                        else {
                            $("#ButtonAfterSomethingChange").show();
                        }
                        $("#ViewName").show();
                        $("#buttonsFavouriteAndDesktop").show();

                        if (!data.RulesVisibility) {
                            $("#ConditionsForView").hide();
                            $(".filter-conditions-toggle-icon").show();
                            $("#ViewUpIcon").hide();
                        }
                        else {
                            $("#ViewUpIcon").show();
                        }
                    }
                    if (data.CanEdit) {
                        var childrenCount = -1;
                        if (data.Rules == 0) {
                            $("#AddButtonAfterDeleteAllRules").show();
                        }
                        for (var i = 0; i < data.Rules.length; i++) {
                            $("#ConditionsForView").append($("#NewRowForCondition").html());

                            var options = createOptionsForColumnType(data.Fields);

                            $("#ConditionsForView").find(".relationship").last().val(data.Rules[i].AndOrOr);
                            $("#ConditionsForView").find(".column-type").last().append(options);
                            if (data.Rules[i].CustomFormFieldId != null) {
                                $("#ConditionsForView").find(".column-type").last().find("[data-customformfieldid='" + data.Rules[i].CustomFormFieldId + "']").prop('selected', true);
                            }
                            else if (data.Rules[i].SlaId != null) {
                                $("#ConditionsForView").find(".column-type").last().find("[data-slaid='" + data.Rules[i].SlaId + "']").prop('selected', true);
                            }
                            else if (data.Rules[i].PriorityId != null) {
                                $("#ConditionsForView").find(".column-type").last().find("[data-priorityid='" + data.Rules[i].PriorityId + "']").prop('selected', true);
                            }
                            else if (data.Rules[i].CategoryId != null) {
                                $("#ConditionsForView").find(".column-type").last().find("[data-categoryid='" + data.Rules[i].CategoryId + "']").prop('selected', true);
                            }
                            else if (data.Rules[i].PortalId != null) {
                                $("#ConditionsForView").find(".column-type").last().find("[data-portalid='" + data.Rules[i].PortalId + "']").prop('selected', true);
                            }
                            else {
                                $("#ConditionsForView").find(".column-type").last().val(data.Rules[i].RuleId);
                            }

                            for (var j = 0 ; j < data.Rules[i].Operators.length; j++) {
                                $("#ConditionsForView").find(".column-operators").last().append("<option value='" + data.Rules[i].Operators[j].Value + "'>" + data.Rules[i].Operators[j].Text + "</option>");
                            }
                            $("#ConditionsForView").find(".column-operators").last().val(data.Rules[i].Operator);
                            reloadTree();
                            $("#ConditionsForView").find(".column-operators").last().show();
                            childrenCount++;
                            var operator_ddl = $("#CT" + (childrenCount)).parent();
                            setDataToRule(operator_ddl, data, i, (childrenCount));

                            if (data.Rules[i].Children != undefined) {
                                childrenCount += addChildren(data.Rules[i].Children, options, 1, childrenCount);
                            }
                        }

                        $("#ConditionsForView").find(".column-type").select2({ dropdownAutoWidth: true });
                        $("#ConditionsForView").find(".column-operators").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
                    }

                    reloadTree();
                }
            }
        })
        .fail(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });
    }

    submitFormList();
}

function addChildren(children, options, depth, childrenCount) {

    var depthElement = $("#ConditionsForView").children(".condition-for-view").last().children(".sub-children");

    for (var d = 1; d < depth; d++) {
        depthElement = $(depthElement).children(".condition-for-view").last().children(".sub-children");
    }

    for (var i = 0; i < children.length; i++) {
        childrenCount++;
        $(depthElement).append($("#NewRowForCondition").html());
        $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".relationship").val(children[i].AndOrOr);
        $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").append(options);
        if (children[i].CustomFormFieldId != null) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").find("[data-customformfieldid='" + children[i].CustomFormFieldId + "']").prop('selected', true);
        }
        else if (children[i].SlaId != null) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").find("[data-slaid='" + children[i].SlaId + "']").prop('selected', true);
        }
        else if (children[i].PriorityId != null) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").find("[data-priorityid='" + children[i].PriorityId + "']").prop('selected', true);
        }
        else if (children[i].CategoryId != null) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").find("[data-categoryid='" + children[i].CategoryId + "']").prop('selected', true);
        }
        else if (children[i].PortalId != null) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").find("[data-portalid='" + children[i].PortalId + "']").prop('selected', true);
        }
        else {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-type").val(children[i].RuleId);
        }
        for (var j = 0 ; j < children[i].Operators.length; j++) {
            $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-operators").last().append("<option value='" + children[i].Operators[j].Value + "'>" + children[i].Operators[j].Text + "</option>");
        }
        $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-operators").last().val(children[i].Operator);
        reloadTree();
        $(depthElement).children(".condition-for-view").last().children(".condition-selects").children(".column-operators").last().show();
        var operator_ddl = $(depthElement).children(".condition-for-view").last().children(".condition-selects");

        setDataToRule(operator_ddl, children, i, (childrenCount));
        if (children[i].Children != undefined) {
            childrenCount += addChildren(children[i].Children, options, (depth + 1), childrenCount );
        }
    }
    return childrenCount;
}

function setDataToRule(operator_ddl, data, i, index) {
    if (data.value == undefined) {
        data.value = "";
    }
    if (data.Rules != undefined) {
        if (data.Rules[i].FieldType.Type == "spinner") {
            spinnerWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
        else if (data.Rules[i].FieldType.Type == "textbox") {
            textboxWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
        else if (data.Rules[i].FieldType.Type == "date") {
            dateWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
        else if (data.Rules[i].FieldType.Type == "time") {
            timeWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
        else if (data.Rules[i].FieldType.Type == "dropdown") {
            dropdownWithValue(operator_ddl, index, data.Rules[i].FieldType.Options, data.Rules[i].Values);
        }
        else if (data.Rules[i].FieldType.Type == "dropdown_client") {
            dropdownClientWithValue(operator_ddl, index, data.Rules[i].FieldType.Options, data.Rules[i].Values);
        }
        else if (data.Rules[i].FieldType.Type == "dropdown_customer") {
            dropdownCustomerWithValue(operator_ddl, index, data.Rules[i].FieldType.Options, data.Rules[i].Values);
        }
        else if (data.Rules[i].FieldType.Type == "dropdowntree") {
            dropdownServiceTreeValue(operator_ddl, index, data.Rules[i].FieldType.Tree, data.Rules[i].Values);
        }
    }
    else if ($.isArray(data)) {
        if (data[i].FieldType.Type == "spinner") {
            spinnerWithValue(operator_ddl, index, data[i].Values[0]);
        }
        else if (data[i].FieldType.Type == "textbox") {
            textboxWithValue(operator_ddl, index, data[i].Values[0]);
        }
        else if (data[i].FieldType.Type == "date") {
            dateWithValue(operator_ddl, index, data[i].Values[0]);
        }
        else if (data[i].FieldType.Type == "time") {
            timeWithValue(operator_ddl, index, data[i].Values[0]);
        }
        else if (data[i].FieldType.Type == "dropdown") {
            dropdownWithValue(operator_ddl, index, data[i].FieldType.Options, data[i].Values);
        }
        else if (data[i].FieldType.Type == "dropdown_client") {
            dropdownClientWithValue(operator_ddl, index, data[i].FieldType.Options, data[i].Values);
        }
        else if (data[i].FieldType.Type == "dropdown_customer") {
            dropdownCustomerWithValue(operator_ddl, index, data[i].FieldType.Options, data[i].Values);
        }
        else if (data[i].FieldType.Type == "dropdowntree") {
            dropdownServiceTreeValue(operator_ddl, index, data[i].FieldType.Tree, data[i].Values);
        }
    }
    else {
        if (data.Type == "spinner") {
            operator_ddl.after('<input type="text" value="' + data.value + '" class="spinner value" id="FSV' + index + '" name="FSV' + index + '" />');
            initSpinnersAndDatePickers();
        }
        else if (data.Type == "textbox") {
            operator_ddl.after('<input type="text" class="left text value" id="FSV' + index + '" name="FSV' + index + '" />');
            initSpinnersAndDatePickers();
        }
        else if (data.Type == "date") {
            operator_ddl.after('<input type="text" value="' + data.value + '" class="left datepickerCanEmpty value" name="FSV' + index + '" id="FSV' + index + '" />');
            initSpinnersAndDatePickers();
        }
        else if (data.Type == "time") {
            operator_ddl.after('<input type="text" value="' + data.value + '" class="left time value" name="FSV' + index + '" id="FSV' + index + '" placehoder="např. 2h 30m" />');
            initSpinnersAndDatePickers();
        }
        else if (data.Type == "dropdown_client") {
            operator_ddl.after('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" name="FSV' + index + '" id="FSV' + index + '"></select>');
            $("#FSV" + index).select2({
                minimumInputLength: 0,
                multiple: true,
                placeholder: Localization_Search,
                ajax: {
                    url: RQ_URL + '/Account/UsersForSelect2Ajax',
                    type: "POST",
                    dataType: 'json',
                    delay: 250,
                    data: function (params) {
                        return {
                            pageSize: 10,
                            pageNum: params.page || 1,
                            term: params.term,
                            showEmail: true,
                            searchInEmail: true,
                        };
                    },
                    processResults: function (data, params) {
                        params.page = data.PageNum;
                        if (data.PageNum == 1) {
                            data.Results.unshift(logged_user_select2_data_option);
                        }

                        return {
                            results: data.Results,
                            pagination: {
                                more: (data.PageNum * data.PageSize) < data.Total
                            }
                        };
                    },
                    cache: true,
                },
                escapeMarkup: function (markup) { return markup; },
                templateResult: formatUsersForSelect2AjaxData,
                templateSelection: formatUsersForSelect2AjaxElement,
            }).on("change", function (e) {
                setSaveButtonsForEdit(false);
                showDataIfRulesAreAlrightTimer();
            }).addClass("left");
        }
        else if (data.Type == "dropdown_customer") {
            operator_ddl.after('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" name="FSV' + index + '" id="FSV' + index + '"></select>');
            $("#FSV" + index).select2({
                minimumInputLength: 0,
                placeholder: Localization_Search,
                allowClear: true,
                ajax: {
                    url: RQ_URL + '/Customers/CustomersForSelect2Ajax',
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    data: function (params) {
                        return {
                            pageSize: 10,
                            pageNum: params.page || 1,
                            term: params.term,
                        };
                    },
                    processResults: function (data, params) {
                        params.page = data.PageNum;
                        data.Results.unshift(logged_user_select2_data_option_without_customer);

                        return {
                            results: data.Results,
                            pagination:
                            {
                                more: (data.PageNum * data.PageSize) < data.Total
                            }
                        };
                    },
                    cache: false,
                }
            }).on("change", function (e) {
                setSaveButtonsForEdit(false);
                showDataIfRulesAreAlrightTimer();
            }).addClass("left");
        }
        else if (data.Type == "dropdown") {
            operator_ddl.after('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" name="FSV' + index + '" id="FSV' + index + '"></select>');
            var options;
            var groupName = null;
            var firstGroupName = false;
            $(data.Options).each(function () {
                if (this.Group != null) {
                    if (groupName != this.Group.Name) {
                        if (firstGroupName) {
                            options += "</optgroup>";
                        }
                        firstGroupName = true;
                        groupName = this.Group.Name;
                        options += "<optgroup label='" + htmlEncode(groupName) + "'>";
                    }
                }
                options += "<option value='" + this.Value + "' " + (this.Disabled ? "disabled" : "") + " >" + htmlEncode(this.Text) + "</option>";
            });
            if (firstGroupName) {
                options += "</optgroup>";
            }
            $("#FSV" + index).html(options);
            $("#FSV" + index).select2({ placeholder: Localization_SelectInSelect, templateSelection: formatOptionGroupSelect }).on("change", function (e) {
                setSaveButtonsForEdit(false);
                showDataIfRulesAreAlrightTimer();
            }).addClass("left");
        }
        else if (data.Type == "dropdowntree") {
            var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" id="FSV' + index + '" name="FSV' + index + '" ></select>');
            operator_ddl.after(dropdown);

            var optgroup = null;

            $(data.Tree).each(function () {
                if (this.IsDepartment) {
                    optgroup = $(document.createElement('optgroup'))
                    .attr('label', htmlDecode(Array(this.Depth + 1).join("&nbsp;&nbsp;&nbsp;&nbsp;")) + this.Name)
                    .appendTo(dropdown);
                }
                else {
                    var option = $(document.createElement('option'))
                    .attr('value', this.Id)
                    .attr('title', this.Description)
                    .html(Array(this.Depth).join("&nbsp;&nbsp;&nbsp;&nbsp;") + htmlEncode(this.Name));

                    option.appendTo(optgroup !== null ? optgroup : dropdown);
                }
            });
            $("#FSV" + index).select2({ placeholder: Localization_SelectInSelect }).on("change", function (e) {
                setSaveButtonsForEdit(false);
                showDataIfRulesAreAlrightTimer();
            });
        }
    }
}

var deleteId = 0;
var refreshManageTable = false;

function deleteViewFromManageViews(id) {
    deleteId = id;
    refreshManageTable = true;
    $("#dialog-Delete-View").dialog("open");
}

function deleteView() {
    deleteId = viewId;
    refreshManageTable = false;
    $("#dialog-Delete-View").dialog("open");
}

function createOptionsForColumnType(fields) {
    var currentGroupKey;
    var groupOpened = false;
    var options = "<option value='-1'>" + Localization_SelectInSelect + "</option>";

    for (var j = 0; j < fields.length; j++) {
        if (currentGroupKey != fields[j].GroupKey) {
            currentGroupKey = fields[j].GroupKey;

            if (groupOpened) {
                options += "</optgroup>";
            }

            options += '<optgroup label="' + fields[j].GroupName + '" value="' + fields[j].GroupKey + '">';
            groupOpened = true;
        }
        var htmlattributes = "";
        $(fields[j].HtmlAttributes).each(function () {
            htmlattributes += " " + this.Name + "='" + this.Value + "'";
        });

        options += "<option value='" + fields[j].Value + "'" + htmlattributes + ">" + fields[j].Text + "</option>";
    }
    if (groupOpened) {
        options += "</optgroup>";
    }
    return options;
}

var replaceNameInViewDetail = false;

function settingsView() {
    replaceNameInViewDetail = true;
    showViewSettingsDialog(viewId);
}

function settingsViewFromManageViews(id) {
    replaceNameInViewDetail = false;
    showViewSettingsDialog(id);
}

function showViewSettingsDialog(id) {
    $("#dialog-New-View").html("<div class='loading-32'></div>");
    $("#dialog-Settings-View").html("<div class='loading-32'></div>");
    $("#dialog-Settings-View").dialog("open");
    $("#dialog-Settings-View").load(RQ_URL + "/View/GetUpdateView/" + id, function () {
        $(".colorSelector-input").each(function () {
            InitColorPicker($(this));
        });

        SearchableCombos();
        $("#dialog-Settings-View").dialog("close");//recenter
        $("#dialog-Settings-View").dialog("open");
    });
}

function saveSettings() {
    if ($("#DialogViewName").val() == "") {
        $("#DialogViewNameErrorMessage").show();
    }
    else {
        $.ajax({
            url: RQ_URL + '/View/SaveSettings',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $("#DialogViewId").val(),
                name: $("#DialogViewName").val(),
                color: $("#DialogViewColor").val(),
                groupId: $("#DialogViewGroup").val(),
            }),
            success: function (data) {
                if (replaceNameInViewDetail) {
                    $("#ViewName").text(data.name);
                    $("#PersonalView" + data.id + " .view-name > span").text(data.name);
                    $("#PersonalView" + data.id + " .view-color-box").css("background-color", data.color);
                    reloadViewGroups();
                }
                else {
                    if ($("#dialogViewTitle" + data.id).length > 0) {
                        $("#dialogViewTitle" + data.id).text(data.name);
                    }
                }
                $("#DialogSettingsViewName").val("");
                cancelRenameDialog();
            },
        });
    }
}

function cancelRenameDialog() {
    $("#dialog-Settings-View").dialog('close');
}

//functions for create input in row
function spinnerWithValue(operator_ddl, index, value) {
    var spinner = $('<input type="text" value="" class="spinner value" id="FSV' + index + '" name="FSV' + index + '" />');
    operator_ddl.after(spinner);
    $(spinner).val(value);
    initSpinnersAndDatePickers();
}

function textboxWithValue(operator_ddl, index, value) {
    var textbox = $('<input type="text" class="left text value" id="FSV' + index + '" name="FSV' + index + '" />');
    operator_ddl.after(textbox);
    $(textbox).val(value);
    initSpinnersAndDatePickers();
}

function dateWithValue(operator_ddl, index, value) {
    var date = $('<input type="text" value="' + value + '" class="left datepickerCanEmpty value" id="FSV' + index + '" name="FSV' + index + '" />');
    operator_ddl.after(date);
    $(date).val(value);
    initSpinnersAndDatePickers();
}

function timeWithValue(operator_ddl, index, value) {
    var time = $('<input type="text" value="' + value + '" class="left time value" id="FSV' + index + '" name="FSV' + index + '" placeholder="např. 2h 30m" />');
    operator_ddl.after(time);
    $(time).val(value);
    initSpinnersAndDatePickers();
}

function dropdownServiceTreeValue(operator_ddl, index, optionsData, values) {
    var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" id="FSV' + index + '" name="FSV' + index + '" ></select>');
    operator_ddl.after(dropdown);
    options = "";
    var optgroup = null;

    $(optionsData).each(function () {

        if (this.IsDepartment) {
            optgroup = $(document.createElement('optgroup'))
            .attr('label', htmlDecode(Array(this.Depth + 1).join("&nbsp;&nbsp;&nbsp;&nbsp;")) + this.Name)
            .appendTo(dropdown);
        }
        else {
            var option = $(document.createElement('option'))
            .attr('value', this.Id)
            .attr('title', this.Description)
            .html(Array(this.Depth).join("&nbsp;&nbsp;&nbsp;&nbsp;") + htmlEncode(this.Name));

            option.appendTo(optgroup !== null ? optgroup : dropdown);
        }
    });
    //placeholder: "Vyberte...R"
    var initialize = true;
    $(dropdown).select2({}).on("change", function (e) {
        if (!initialize) {
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
            sendViewId = false;
        }
        initialize = false;
    });
    $(dropdown).val(values).trigger("change");
}


function dropdownCustomerWithValue(operator_ddl, index, optionsData, values) {
    var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" id="FSV' + index + '" name="FSV' + index + '" ></select>');
    operator_ddl.after(dropdown);
    options = "";
    $(optionsData).each(function () {
        options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
    });
    dropdown.html(options);
    var initialize = true;
    dropdown.select2({
        minimumInputLength: 0,
        placeholder: Localization_Search,
        allowClear: true,
        ajax: {
            url: RQ_URL + '/Customers/CustomersForSelect2Ajax',
            type: 'POST',
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;
                data.Results.unshift(logged_user_select2_data_option_without_customer);

                return {
                    results: data.Results,
                    pagination:
                    {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: false,
        }
    });

    dropdown.on("change", function (e) {
        if (!initialize) {
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
            sendViewId = false;
        }
        initialize = false;
    }).addClass("left");

    dropdown.val(values).trigger("change");
}

function dropdownClientWithValue(operator_ddl, index, optionsData, values) {
    var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" id="FSV' + index + '" name="FSV' + index + '" ></select>');
    operator_ddl.after(dropdown);
    options = "";
    $(optionsData).each(function () {
        options += "<option value='" + this.Value + "'>" + htmlEncode(this.Text) + "</option>";
    });
    dropdown.html(options);
    var initialize = true;
    dropdown.select2({
        minimumInputLength: 0,
        multiple: true,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                    searchInEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;
                data.Results.unshift(logged_user_select2_data_option);

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: false,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    dropdown.on("change", function (e) {
        if (!initialize) {
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
            sendViewId = false;
        }
        initialize = false;
    }).addClass("left");

    dropdown.val(values).trigger("change");
}

function dropdownWithValue(operator_ddl, index, optionsData, values) {
    var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" id="FSV' + index + '" name="FSV' + index + '" ></select>');
    operator_ddl.after(dropdown);
    options = "";
    var groupName = null;
    var firstGroupName = false;
    $(optionsData).each(function () {
        if (this.Group != null) {
            if (groupName != this.Group.Name) {
                if (firstGroupName) {
                    options += "</optgroup>";
                }
                firstGroupName = true;
                groupName = this.Group.Name;
                options += "<optgroup label='" + htmlEncode(groupName) + "'>";
            }
        }
        options += "<option value='" + this.Value + "' " + (this.Disabled ? "disabled" : "") +" >" + htmlEncode(this.Text) + "</option>";
    });
    if (firstGroupName) {
        options += "</optgroup>";
    }
    $(dropdown).html(options);
    //placeholder: "Vyberte...R"
    var initialize = true;
    $(dropdown).select2({ templateSelection: formatOptionGroupSelect }).on("change", function (e) {
        if (!initialize) {
            setSaveButtonsForEdit(false);
            showDataIfRulesAreAlrightTimer();
            sendViewId = false;
        }
        initialize = false;
    });
    $(dropdown).val(values).trigger("change");
}

//id pro share dialog
var dialogId = -1;

function shareViewGroup(id) {
    dialogId = id;
    $("#dialog-Share-View-Group").dialog("open");
}

function saveShareSettings() {
    $.ajax({
        url: RQ_URL + '/View/SetShareSettings',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            Id: $("#ShareViewGroupId").val(),
            Type: $("#dialog-Share-View-Group").find("input[name='ShareViewGroupType']:checked").val(),
            InternalGroups: $("#InternalGroups").val(),
            OperatorGroups: $("#OperatorGroups").val(),
            Customers: $("#Customers").val(),
            CustomerGroups: $("#CustomerGroups").val(),
            Users: $("#Users").val(),
            AdministratorsCanEdit: $("#ShareDialogAdministratorsCanEdit").is(":checked"),
            ShowOnDesktopDefaultValue: $("#ShareDialogShowOnDesktopDefaultValue").is(":checked"),
        }),
        success: function (g) {
            cancelShareViewGroupDialog();
            if (managerVisibleTable) {
                reloadManageViewShowDivForLoading = true;
                reloadManageViewsTable();
            }
        },
        error: function (error) {
            alert(error.responseText);
        },
    });
}

function manageViews() {
    $("#dialog-Manage-Views").html("<div class='loading-32'></div>");
    $("#dialog-Manage-Views").dialog("open");
    $.ajax({
        url: RQ_URL + '/View/AllViews',
        type: "GET",
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        $("#dialog-Manage-Views").html(data);
        refreshAfterCloseViewManager = false;
        reloadManageViewShowDivForLoading = false;
        $("#dialog-Manage-Views").dialog("close");
        $("#dialog-Manage-Views").dialog("open"); //recenter
        managerVisibleTable = true;
        OnAjaxComplete();
    });
}

function reloadManageViewsTable() {
    if (reloadManageViewShowDivForLoading) {
        OnAjaxBegin(Localization_LoadingViews);
    }
    else {
        $("#dialog-Manage-Views").html("<div class='loading-32'></div>");
    }
    $.ajax({
        url: RQ_URL + '/View/AllViews',
        type: "GET",
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        $("#dialog-Manage-Views").html(data);
        OnAjaxComplete();
    });
}

var sendViewId = false;

function makeModel() {
    positionForSend = 0;
    var arrayForSend = findSubcondition($("#ConditionsForView").children(".condition-for-view"));
    $("#SendData").empty();
    $("#SendData").append("<input type='hidden' name='BaseTicketSet' value='" + $("#BaseTicketSet").val() + "' />");
    $("#SendData").append("<input type='hidden' name='Archive' value='" + $('#hiddenArchive').val() + "' />");

    if (sendViewId && viewId != -1) {
        $("#SelectedDataSource").val(VIEW);
        $("#SendData").append("<input type='hidden' name='ViewId' value='" + viewId + "' />");
    }
    if (viewId != -1) {
        $("#SendData").append("<input type='hidden' name='ViewIdLast' value='" + viewId + "' />");
    }
    if (arrayForSend.length > 0) {
        $("#SelectedDataSource").val(VIEW);
    }
    for (var i = 0; i < arrayForSend.length; i++) {
        addItemsToForm("RulesModel[" + i + "]", arrayForSend[i]);
        if (arrayForSend[i].Children.length > 0) {
            createTree("RulesModel[" + i + "]", arrayForSend[i].Children);
        }
    }
}

//if (!String.prototype.startsWith) {
//    String.prototype.startsWith = function (searchString, position) {
//        position = position || 0;
//        return this.indexOf(searchString, position) === position;
//    };
//}

function submitFormList() {
    //if ($('#hiddenSortBy').val().startsWith('SlaId'))
    //    $('#hiddenSortBy').val('ticket.Id');

    $("#tickets-table tbody").hide();
    $("#TicketsTableLoadingRow").show();
    loadPage = false;
    makeModel();

    var array = $('#ticketsForm').serializeObject();
    var data = JSON.stringify(array);

    $.ajax({
        url: RQ_URL + '/Tickets/LoadTickets',
        type: "POST",
        data: data,
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        cache: false,
        success: function (data) {

            if (errorConditions) {
                HideError();
            }
            //bez pohledu = vsechny || pohled
            if ((!sendViewId && ((!newView && ($(data).find("#SelectedDataSource").val() == ALL)) || ((newView || editView) && $(data).find("#SelectedDataSource").val() == VIEW))) || (sendViewId && ($(data).find("#ViewId").val() == viewId || ($(data).find("#ViewId").val() == "" && viewId == -1)))) {
                $("#ticketsDiv").html(data);

                var cursorTicketId = $('#hiddenCursorTicketId').val();
                var $tr = $('#tickets-table tr.ticket-row[data-ticket-id="' + cursorTicketId + '"]').addClass('cursor');

                $("#TicketsTableLoadingRow").hide();
            }

            if (pageLoadingFirstTime) {
                pageLoadingFirstTime = false;
                var views = $("ul.personal-views:visible li.personal-view:not(.selected):not(.js-do-not-load-count)"); //selected count se predava z _Tickets v document ready

                myViewsWaitingToLoadCount.push(null);
                for (var i = 0; i < views.length; i++) {
                    myViewsWaitingToLoadCount.push($(views[i]).attr("data-id"));
                }

                setTimeout(function () { loadTicketsCountFromArray(false); }, 250);  //setTimeout Chrome workaround
            }
        },
        error: function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        },
    });
}

$.fn.serializeObject = function () {
    var o = {};
    var a = this.serializeArray();
    $.each(a, function () {
        if (o[this.name] !== undefined) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
};

function removeDraft() {
    $("#DraftId").val(null);
}

function selectDraft(id) {
    $("#AddButtonAfterDeleteAllRules").hide();
    ticketIdsArray = new Array();
    RefreshTicketCheckboxAllCount();
    $("#dialog-Manage-Views").dialog("close");
    managerVisibleTable = false;
    $("#SelectedDataSource").val(VIEW);
    newView = true;
    editView = false;
    sendViewId = false;
    $("#DraftId").val(id);
    defaultButtonVisibilityForView();
    $("#ConditionsForView").empty();
    $(".filter-conditions-toggle-icon").hide();
    $(".filter-conditions-toggle-icon").hide();
    $("#ViewBaseTicketSet").hide();
    $("#ViewUpIcon").hide();
    $("#ViewName").text($("#PersonalView" + id).find(".view-name").html());
    $("#ViewLoading").show();
    $(".personal-view").removeClass("selected");
    //OnAjaxBegin("Načítám pohled...");
    $.ajax({
        url: RQ_URL + '/View/GetViewDraft?id=' + id,
        type: "GET",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        if (data.Id == id) {
            $("#DraftId").val(data.Id);
            $("#ViewName").text(data.Name);
            if ($("#BaseTicketSet").length > 0) {
                reloadTicketBaseTicketSet = false;
                $("#BaseTicketSet").val(data.BaseTicketSet).trigger("change");
            }
            $("#ConditionsForView").empty();
            if (!data.CanEdit) {
                $("#ConditionsForView").hide();
                var div = $("#ViewName").parent();
                div.children().hide();
                $("#ViewName").show();
                $("#buttonsFavouriteAndDesktop").show();
            }
            else {
                defaultButtonVisibilityForView();
                $("#ConditionsForView").show();
                var div = $("#ViewName").parent();
                div.children().hide();
                $("#ViewBaseTicketSet").show();
                $("#ButtonAfterSomethingChange").hide();
                $("#ManagerButton").hide();
                $("#SaveView").show();
                $("#ViewName").show();
            }
            if (data.CanEdit) {
                var childrenCount = 0;
                if (data.Rules == 0) {
                    $("#AddButtonAfterDeleteAllRules").show();
                }
                for (var i = 0; i < data.Rules.length; i++) {
                    $("#ConditionsForView").append($("#NewRowForCondition").html());

                    var options = createOptionsForColumnType(data.Fields);

                    $("#ConditionsForView").find(".relationship").last().val(data.Rules[i].AndOrOr);
                    $("#ConditionsForView").find(".column-type").last().append(options);
                    if (data.Rules[i].CustomFormFieldId != null) {
                        $("#ConditionsForView").find(".column-type").last().find("[data-customformfieldid='" + data.Rules[i].CustomFormFieldId + "']").prop('selected', true);
                    }
                    else if (data.Rules[i].SlaId != null) {
                        $("#ConditionsForView").find(".column-type").last().find("[data-slaid='" + data.Rules[i].SlaId + "']").prop('selected', true);
                    }
                    else if (data.Rules[i].PriorityId != null) {
                        $("#ConditionsForView").find(".column-type").last().find("[data-priorityid='" + data.Rules[i].PriorityId + "']").prop('selected', true);
                    }
                    else if (data.Rules[i].CategoryId != null) {
                        $("#ConditionsForView").find(".column-type").last().find("[data-categoryid='" + data.Rules[i].CategoryId + "']").prop('selected', true);
                    }
                    else if (data.Rules[i].PortalId != null) {
                        $("#ConditionsForView").find(".column-type").last().find("[data-portalid='" + data.Rules[i].PortalId + "']").prop('selected', true);
                    }
                    else {
                        $("#ConditionsForView").find(".column-type").last().val(data.Rules[i].RuleId);
                    }

                    for (var j = 0 ; j < data.Rules[i].Operators.length; j++) {
                        $("#ConditionsForView").find(".column-operators").last().append("<option value='" + data.Rules[i].Operators[j].Value + "'>" + data.Rules[i].Operators[j].Text + "</option>");
                    }
                    $("#ConditionsForView").find(".column-operators").last().val(data.Rules[i].Operator);
                    reloadTree();
                    $("#ConditionsForView").find(".column-operators").last().show();
                    childrenCount += i;
                    var operator_ddl = $("#CT" + (childrenCount)).parent();
                    setDataToRule(operator_ddl, data, i, (childrenCount));

                    if (data.Rules[i].Children != undefined) {
                        childrenCount++;
                        childrenCount += addChildren(data.Rules[i].Children, options, 1, childrenCount);
                    }
                }

                $("#ConditionsForView").find(".column-type").select2({ dropdownAutoWidth: true });
                $("#ConditionsForView").find(".column-operators").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
            }

            submitFormList();
        }
    })
    .fail(function (error) {
        if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
    });

}

function refreshTicketsCountInAll(count) {
    $("li.personal-view .badge .fas.fa-sync-alt").remove();
    $("li.personal-view .badge .tickets-count").show();
    $("#AllTickets").addClass('fresh').find(".badge .tickets-count").text(count);
    $("#AllTickets").find(".badge").fadeIn();
}

function refreshTicketsCountInView(viewId, count) {
    $("li.personal-view .badge .fas.fa-sync-alt").remove();
    $("li.personal-view .badge .tickets-count").show();
    $("#PersonalView" + viewId).addClass('fresh').find(".badge .tickets-count").text(count);
    $("#PersonalView" + viewId).find(".badge").fadeIn();
}

function reloadViewActiveOrArchiveTab() {
    cancelLoadingViewsCount();
    $('.views .personal-view:not(.js-do-not-load-count) .badge').hide();
    $('.views .personal-view.js-do-not-load-count .badge .tickets-count').text('*');

    pageLoadingFirstTime = true;

    if ($("#DraftId").val() == "") { // je to draft nechám vše jak je a jen přenačtu
        reloadView();
    }
    else {
        submitFormList();
    }
}

function refreshTicketAgeTexts() {
    $(".ticket-age-text").each(function () {
        setTicketAgeTextFromDate($(this));
    });
}

function setPageTitleBadge(count) {
    var withoutBadge = document.title.replace(/^\([0-9]+\) /g, '');

    if (count > 0) {
        document.title = '(' + count + ') ' + withoutBadge;
    }
    else {
        document.title = withoutBadge;
    }
}

function createGroup() {
    $("#dialog-Group").html("<div class='loading-32'></div>");
    $("#dialog-Group").dialog("open");
    $("#dialog-Group").load(RQ_URL + "/View/GetNewViewGroup", function () {

        $(".colorSelector-input").each(function () {
            InitColorPicker($(this));
        });

        $("#dialog-Group").dialog("close");//recenter
        $("#dialog-Group").dialog("open");
    });
}

function editGroup(id) {
    $("#dialog-Group").html("<div class='loading-32'></div>");
    $("#dialog-Group").dialog("open");
    $("#dialog-Group").load(RQ_URL + "/View/GetUpdateViewGroup/" + id, function () {
        $(".colorSelector-input").each(function () {
            InitColorPicker($(this));
        });

        $("#dialog-Group").dialog("close");//recenter
        $("#dialog-Group").dialog("open");
    });
}

function saveGroup() {
    if ($("#DialogGroupName").val() == "") {
        $("#DialogGroupNameErrorMessage").show();
    }
    else {
        $.ajax({
            url: RQ_URL + '/View/SaveGroup',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: $("#DialogGroupId").val(),
                name: $("#DialogGroupName").val(),
                color: $("#DialogGroupColor").val(),
            }),
            success: function (g) {

                if ($("#dialogGroupTitle" + $("#DialogGroupId").val()).length > 0) {
                    $("#dialogGroupTitle" + $("#DialogGroupId").val()).text($("#DialogGroupName").val());
                }
                //nová skupina musím dát refresh
                if ($("#DialogGroupId").val() == "") {
                    reloadViewGroups();
                } else { // při editaci jen vymění text a barvu
                    $(".js-view-group[data-id=" + $("#DialogGroupId").val() + "] .js-view-group-title .js-name").text($("#DialogGroupName").val());
                    $(".js-view-group[data-id=" + $("#DialogGroupId").val() + "] .js-view-group-title .fa-chevron-down").css("color", $("#DialogGroupColor").val());
                    $(".js-view-group[data-id=" + $("#DialogGroupId").val() + "] .js-view-group-title .fa-chevron-right").css("color", $("#DialogGroupColor").val());
                }
                $("#dialog-Group").dialog("close");
            },
            error: function (error) {
                alert(error.responseText);
            },
        });
    }
}

function reloadViewsForGroup(viewGroupId) {
    $(".js-view-group[data-id=" + viewGroupId + "] .views").prepend("<div class='loading-16'></div>");
    $(".js-view-group[data-id=" + viewGroupId + "] .views").load(RQ_URL + "/View/ReloadViewsForGroup/" + viewGroupId, function () {
        initPersonalViewsSortable();
        $("#PersonalViews").disableSelection();
        if ($(".js-view-group[data-id='" + viewGroupId + "'] .fa-chevron-right").is(":visible"))
            $(".js-view-group[data-id='" + viewGroupId + "'] .fa-chevron-right").trigger("click");
    });
}

function reloadViewGroups() {
    if (!refreshRotationGlobalTimeoutRunning) {
        refreshRotationGlobalTimeoutRunning = true;
        AnimateRotateGlobalRefreshButton($('#views-refresh').find('i.fa-sync-alt'), 360, "infinite");
    }
    $(".view-groups").load(RQ_URL + "/View/ReloadGroups", function () {
        $("#AllTickets").removeClass('changed').find(".badge").hide();

        if (viewId != -1) {
            $(".personal-view").removeClass("selected");
            $("#PersonalView" + viewId).addClass("selected");

            newView = false;
        }

        initPersonalViewsSortable();
        $("#PersonalViews").disableSelection();

        myViewsWaitingToLoadCount.push(null);
        count = $('ul.personal-views:visible li.personal-view').length;
        if (count == 0) // když nejsou žádné pohledy tak aby se načetli sumace
            loadTicketsCountFromArray(true);
        $('ul.personal-views:visible li.personal-view').each(function () {
            myViewsWaitingToLoadCount.push($(this).data('id'));
            if (!--count)
                loadTicketsCountFromArray(true);
        });

        OnAjaxComplete();
    });
}

function deleteViewGroupFromManageViews(id, manageTable) {
    deleteGroupId = id;
    refreshManageTable = manageTable;
    $("#dialog-Delete-View-Group").dialog("open");
}

function openTicketsBulkActions() {
    $("#dialog-Tickets-Bulk-Actions").html("<div class='loading-32'></div>")
    $("#dialog-Tickets-Bulk-Actions").dialog("open");
    $("#dialog-Tickets-Bulk-Actions").load(RQ_URL + "/Tickets/LoadTicketsBulkActionsDialog", function () {
        $("#dialog-Tickets-Bulk-Actions").dialog("close"); //recenter
        $("#dialog-Tickets-Bulk-Actions").dialog("open");
        Select2Combos();
    });
}

function BulkActionSuccess(result) {
    OnAjaxComplete();
    EnableBulkActionButtons();
    if (result.Success) {
        if (closeBulkDialog) {
            reloadTheTickets = true;
            $("#dialog-Tickets-Bulk-Actions").dialog("close");
            ShowSuccess(result.Message);
        } else {
            $("#TicketsBulkActions").trigger("change");
            $("#TicketsBulkActionsDialog .alert-success").text(result.Message);
            $("#TicketsBulkActionsDialog .alert-success").show();
            $("#TicketsBulkActionsDialog .alert-danger").hide();
        }
    } else {
        $("#dialog-Tickets-Bulk-Actions-Tickets").empty();
        $("#dialog-Tickets-Bulk-Actions-Tickets").html("<div style='padding: 10px; min-height: 100px; max-height: 300px; overflow: auto;' class='control-round-box'></div>");
        $div = $("#dialog-Tickets-Bulk-Actions-Tickets").find("div");
        for (i = 0; i < result.FailedTickets.length; i++) {
            $div.append($('<div></div>').html("[" + result.FailedTickets[i].TicketRef + "] " + result.FailedTickets[i].Subject + " <small style='color:red'>(Kategorie není možná pro danou službu)</small>"));
        }
        $("#dialog-Tickets-Bulk-Actions-Tickets").dialog("open");
    }
}

function BulkActionFailure() {
    EnableBulkActionButtons();
    $("#TicketsBulkActionsDialog .alert-success").show();
    $("#TicketsBulkActionsDialog .alert-success").hide();
}

function DisableBulkActionButtons() {
    $("#BulkActionsPerformAndClose").prop("disabled", true);
    $("#BulkActionsClose").prop("disabled", true);
    $("#BulkActionsPerform").prop("disabled", true);
}

function EnableBulkActionButtons() {
    $("#BulkActionsPerformAndClose").prop("disabled", false);
    $("#BulkActionsClose").prop("disabled", false);
    $("#BulkActionsPerform").prop("disabled", false);
}