﻿//https://github.com/select2/select2/issues/1246
//opravuje nefunkcni vyhledavani select2 uvnitr jquery ui dialogu (v budouci verzi se to muze nejak zmenit)
if ($.ui && $.ui.dialog && $.ui.dialog.prototype._allowInteraction) {
    var ui_dialog_interaction = $.ui.dialog.prototype._allowInteraction;
    $.ui.dialog.prototype._allowInteraction = function (e) {
        if ($(e.target).closest('.select2-dropdown').length) return true;
        return ui_dialog_interaction.apply(this, arguments);
    };
}

jQuery.validator.addMethod(
    "regex",
    function (value, element, regexp) {
        var re = new RegExp(regexp);
        return this.optional(element) || re.test(value);
    },
    Localization_ValidateRegex
);

jQuery.validator.addMethod("ourTime", function (value, element) {
    var input = $(element).val().replace(/ /g, '');
    var regex1 = new RegExp("^[0-9]+:[0-9]{1,2}$");
    var regex2 = new RegExp("^[0-9]+h[0-9]{1,2}m$");
    var regex3 = new RegExp("^[0-9]+m?$");
    var regex4 = new RegExp("^[0-9]+([,\.][0-9]+)?h$");
    return input == "" || input == undefined || regex1.test(input) || regex2.test(input) || regex3.test(input) || regex4.test(input);
}, Localization_TimeValidationMessage);

//nastavi attr disabled, pokud dam prop('disabled', true/false)
$.extend($.propHooks, {
    disabled: {
        set: function (elem, value) {
            if (value)
                elem.setAttribute("disabled", "disabled");
            else
                elem.removeAttribute("disabled");

            return (elem["disabled"] = value);
        }
    }
});

$.ajaxSetup({
    // Disable caching of AJAX responses - doesnt work .load() correctly in IE*/
    cache: false,
});

function isValidEmailAddress(emailAddress) {
    //with international chars
    //var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
    //without international chars
    var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d)|(([a-z]|\d)([a-z]|\d|-|\.|_|~)*([a-z]|\d)))\.)+(([a-z])|(([a-z])([a-z]|\d|-|\.|_|~)*([a-z])))\.?$/i);
    return pattern.test(emailAddress);
};

function htmlEncode(value) {
    //create a in-memory div, set it's inner text(which jQuery automatically encodes)
    //then grab the encoded contents back out.  The div never exists on the page.
    return $('<div/>').text(value).html();
}

function htmlDecode(value) {
    return $('<div/>').html(value).text();
}

jQuery.fn.selectText = function () {
    var doc = document;
    var element = this[0];

    if (doc.body.createTextRange) {
        var range = document.body.createTextRange();
        range.moveToElementText(element);
        range.select();
    } else if (window.getSelection) {
        var selection = window.getSelection();
        var range = document.createRange();
        range.selectNodeContents(element);
        selection.removeAllRanges();
        selection.addRange(range);
    }
};

$(document).ready(function () {
    $('input[type="checkbox"][data-toggle="toggle"]').bootstrapToggle();

    $(document).on('click', '.dropdown-menu .dropdown-menu-item', function (e) {
        e.stopPropagation();
    });

    $(".a-popup").click(function () {
        if ($(this).hasClass('popup-right')) {
            var offset = $(this).outerWidth() - $("#" + $(this).data("popup")).outerWidth();
            $("#" + $(this).data("popup")).css('margin-left', offset + 'px');
        }

        $("#" + $(this).data("popup")).show();
    });

    $("#detailForInventory").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 500
    });

    $('.dropdown-toggle').dropdown();

    $.fn.tooltipBS.Constructor.DEFAULTS.placement = 'bottom'; // Set the default placement
    initBsTooltip();

    //click na cokoli, co na sebe vaze BS tooltip, ho zavre (aby to tam nezustavalo viset, kdyz je focused)
    //$("body").on('click', '[data-toggle="tooltip"][title]', function () {
    //    $(this).tooltipBS('hide');
    //});
    //$("body").click(function () {
    //    $('[data-toggle="tooltip"][title]').tooltipBS('hide');
    //});

    //$('[title]:not([data-content])').tooltipBS({ container: 'body', placement: 'bottom' });

    $('body').on('mouseover', '[data-toggle="tooltip"][data-content]', function (e) {
        $(this).popover({ container: 'body' }).popover('show');
    });

    $('body').on('mouseout', '[data-toggle="tooltip"][data-content]', function (e) {
        $(this).popover('destroy');
    });    

    setTimeout(function () {
        $("section#postback-alert .alert.ok:not(.do-not-hide)").fadeOut('slow');
    }, 3000);

    $('body').on('click', function (e) {
        $('.popover-link').each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('hide');
            }
        });
    });

    $("body").on('click', 'a.user-info', function () {
        var userproviderkey = $(this).data('userproviderkey');
        var userinfo = $(this);
        userinfo.popover({
            container: 'body',
            content: '<div class="loading-32"></div>',
            placement: 'auto',
            html: true,
        });
        userinfo.popover('show');
        var popover = userinfo.data('bs.popover');

        $.post(
            RQ_URL + "/Account/UserInfo",
            {
                userproviderkey: userproviderkey,
            },
            function (html) {
                //popover.options.content = data; //in BS 4 popover.config.content
                //popover.setContent();
                popover.tip().find('.popover-content').html(html);
            },
            "html"
            )
            .fail(function (error) { alert(error.responseText); });
    });

    $("body").on('click', 'a.customer-info', function () {
        var customerId = $(this).data('id');
        var customerinfo = $(this);
        customerinfo.popover({
            container: 'body',
            content: '<div class="loading-32"></div>',
            placement: 'auto',
            html: true,
            trigger: 'click focus', //Dismiss on next click
        });
        customerinfo.popover('show');
        var popover = customerinfo.data('bs.popover');

        $.post(
            RQ_URL + "/Customers/CustomerInfo",
            {
                customerId: customerId,
            },
            function (data) {
                popover.options.content = data; //in BS 5 popover.config.content
                popover.setContent();
            },
            "html"
            )
            .fail(function (error) { alert(error.responseText); });

    });

    //toto uz slouzi jen jako pojistka, samotne schovani zajistuje trigger: 'click focus', ale obcas to jeste nefunguje dobre pri vicekliku a toto zachranuje
    $('body').on('click', function (e) { //to close popover when clicked outside
        $("a.user-info, a.customer-info").each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('destroy');
            }
        });
    });

    $('body').on('click', 'button.detail-info', function (e) {
        $("a.user-info").each(function () {
            if ($(this).attr('aria-describedby') != "" && $(this).attr('aria-describedby') != undefined) {
                var userproviderkey = $(this).data('userproviderkey');
                $(this).popover('destroy');
                $("#detailForInventory").html('<div class="loading-32"></div>');
                $("#detailForInventory").dialog('open');
                $.post(
                   RQ_URL + "/Account/DetailInfo",
                   {
                       userproviderkey: userproviderkey,
                   },
                   function (data) {
                       //$("#detailForInventory").dialog('close');
                       $("#detailForInventory").html(data);
                       //$("#detailForInventory").dialog('open');
                   },
                   "html"
                   )
                   .fail(function (error) { alert(error.responseText); });
            }
        });
    });

    //search button
    var tbSearch = $('#search-input');
    var formSearchFor = $('#formSearchFor');

    formSearchFor.submit(function () {
        return tbSearch.val().trim() != '';
    });

    //tbSearch.change(function () {
    tbSearch.on('input', function () { //This would fire every time the input changes, so when you paste something (even with right click), delete and type anything.
        clearTimeout($.data(this, 'timerGetAutocomplete'));
        var wait = setTimeout(GetAutocomplete, 700); //latence
        $(this).data('timerGetAutocomplete', wait);
    });

    tbSearch.on('search', function () { //reaguje na krizek v Chrome
        GetAutocomplete();
    });

    tbSearch.focus(function () {
        $(this).animate({ width: 800 }, 'fast');
        //GetAutocomplete();
        var $searchInput = $("#search-input");
        var q = $searchInput.val();
        if (q.length >= 3) {
            $("#autocomplete_div").slideDown();
        }
    });

    tbSearch.focusout(function () {
        if (!$("#autocomplete_div").is(':visible')) {
            tbSearch.animate({ width: 200 }, 'fast'); //click mimo prohlizec
        }
    });

    $('#autocomplete_div, #search-input').click(function (event) {
        event.stopPropagation(); // Prevent bubbling
    });

    $('#notification_menu').click(function (event) {
        event.stopPropagation(); // Prevent bubbling
        HideResult();
        $("#notification_div").html("<div class='loading-32'></div>");
        $("#notification_div").slideDown();
        $("#notification_div").load(RQ_URL + "/Notifications/GetNotificationsBoth");
    });

    $("#notification_div").click(function (e) {
        e.stopPropagation();
    });

    $("#notification_div").on("click", "a", function (e) {
        e.stopPropagation();
    });
    
    $("html").click(function () {
        setTimeout(function () { //http://stackoverflow.com/questions/1094332/jquery-blur-fires-before-href
            HideResult();
            HideResultNotifications();
            tbSearch.animate({ width: 200 }, 'fast');
        }, 1);
    });

    $("div.help a").click(function (event) {
        if ($(this).data("help-anchor-name")) {
            event.preventDefault();

            var dialog = $('<div style="display:none" class="help-dialog loading"><img id="imgIndicatiorWaitAnim" src="' + RQ_URL + '/Images/Desktop/ajax-loader.gif" alt="' + Localization_LoadingPleaseWait + '" /></div>').appendTo('body');
            // open the dialog
            dialog.dialog({
                // add a close listener to prevent adding multiple divs to the document
                close: function (event, ui) {
                    // remove div with all data and events
                    dialog.remove();
                },
                modal: false,
                width: 750,
                height: 600
            });

            //closes dialog when clicking outside
            jQuery('body').bind('click', function (e) {
                if ($('.help-dialog').dialog('isOpen')
                    && !jQuery(e.target).is('.ui-dialog, a')
                    && !jQuery(e.target).closest('.ui-dialog').length) {
                    $('.help-dialog').dialog('close');
                }
            });

            // load remote content
            /*dialog.load(
                '/Help/GetHtml',
                { anchor: $(this).data("help-anchor-name") },
                function (responseText, textStatus, XMLHttpRequest) {
                    // remove the loading class
                    dialog.removeClass('loading');
                }
            );*/

            $.post(
                RQ_URL + '/HelpManual/Part',
                { anchor: $(this).data("help-anchor-name") },
                function (data) {
                    dialog.dialog('option', 'title', data.title);
                    $('.ui-dialog-titlebar').append('<div style="float:right; position:absolute; right: 50px; font-weight: normal;"><a href="' + data.helplink + '" target="_blank">' + Localization_AdministratorGuide + '</a></div>');
                    dialog.html(data.content);
                },
                "json"
            )
            .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
            .done(function () { });
        }
    });

    SearchableCombos();
    Select2Combos();
    LanguageSelect2();
    
    $("#dialogFeedback").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: '570px',
        buttons: [{
            text: Localization_Send,
            id: "dialogFeedbackSendButton",
            click: function () {
                $("#ValidErrorSubject").hide();
                $("#ValidErrorEmail").hide();
                $("#ValidErrorEmailIsNotValid").hide();
                if ($("#dialogFeedbackEmail").val() == "" || $("#dialogFeedbackSubject").val() == "" || !isValidEmailAddress($("#dialogFeedbackEmail").val())) {
                    if ($("#dialogFeedbackEmail").val() == "") {
                        $("#ValidErrorEmail").show();
                    }
                    else if (!isValidEmailAddress($("#dialogFeedbackEmail").val())) {
                        $("#ValidErrorEmailIsNotValid").show();
                    }
                    if ($("#dialogFeedbackSubject").val() == "") {
                        $("#ValidErrorSubject").show();
                    }
                }
                else {
                    OnAjaxBegin(Localization_SendingPleaseWait);
                    var inputs = $("#dialog-feddback-attachments input");
                    var data = new FormData();
                    data.append("email", $("#dialogFeedbackEmail").val());
                    data.append("subject", $("#dialogFeedbackSubject").val());
                    data.append("text", $("#dialogFeedbackText").val());
                    data.append("type", $("#dialogFeedbackType").val());
                    for (var f = 0; f < inputs.length; f++) {
                        var files = $(inputs[f]).prop("files");
                        if (files.length > 0) {
                            if (window.FormData !== undefined) {
                                for (var x = 0; x < files.length; x++) {
                                    data.append("file" + f, files[x]);
                                }
                            }
                        }
                    }
                    $.ajax({
                        url: RQ_URL + "/Home/SendEmail",
                        type: "POST",
                        contentType: false,
                        processData: false,
                        dataType: 'json',
                        data: data,
                        success: function (g) {
                            OnAjaxComplete();
                            if(g) {
                                $("#dialogFeedbackDefault").hide();
                                $("#dialogSendFeedbackFail").hide();
                                $("#dialogSendFeedbackAlright").show();
                                $("#dialogFeedbackSendButton").hide();
                            }
                            else {
                                $("#dialogFeedbackDefault").hide();
                                $("#dialogSendFeedbackFail").show();
                                $("#dialogSendFeedbackAlright").hide();
                                $("#dialogFeedbackSendButton").hide();
                            }
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    }).parent().find('.ui-dialog-buttonpane').prepend('<div class="dialog-feedback-footer-link"><a href="http://www.requestor.com/">Requestor.com</a></div>');

    LoadAutomaticTicketAssignments();

    (function initObserver() {
        if ($('#divChatEvent_div').length === 0)
            return;

        function toggleChatEvents(show) {
            if (!window.chatDashboard || $('#divCallAlerts li').length > 0) {
                var $divChatEvent = $('#divChatEvent_div');
                show ? $divChatEvent.slideDown() : $divChatEvent.slideUp();
            }
        }

        var activeItemsCount = 0;
        var observer = new MutationObserver(function (mutations) {
            mutations.forEach(function (mutation) {
                if (mutation.type === 'childList') {
                    var activeItemsCountTemp = $('#divChatAlerts > ul > li').length + $('#divCallAlerts li').length;
                    if (activeItemsCountTemp > activeItemsCount && activeItemsCountTemp > 0)
                        toggleChatEvents(true);
                    else if (activeItemsCountTemp === 0)
                        toggleChatEvents(false);

                    activeItemsCount = activeItemsCountTemp;
                }
                else if (mutation.type === 'characterData')
                    toggleChatEvents(true);
            });
        });

        observer.observe(document.getElementById('divChatEvent_div'), { childList: true, characterData: true, subtree: true });
    })();

    $("#aLogOff").click(function (e) {
        if (typeof (Storage) !== "undefined" && localStorage.registeredFcmToken) {
            e.preventDefault();
            window.location.href = $(this).attr("href") + "?" + $.param({ instanceIdToken: localStorage.registeredFcmToken });
            localStorage.removeItem("registeredFcmToken");
        }
    });
}); //end document ready

//pokud je v ajax chyba a odezvou je html dokument, pravdepodobne doslo k chybe parsovani json a obsahem je login stranka
//docasne reseni pro vyprseni login session + ajax
$(document).ajaxError(function (event, request, settings) {
    if (request.responseText != null && request.responseText.includes('<!DOCTYPE html>')) {
        window.location = RQ_URL;
    }
});

// Prevent jQuery UI dialog from blocking focusin
// https://www.tiny.cloud/docs/integrations/jquery/
$(document).on('focusin', function (e) {
    if ($(e.target).closest(".tox-tinymce-aux, .moxman-window, .tam-assetmanager-root").length) {
        e.stopImmediatePropagation();
    }
});


$(window).on("scroll", function (e) {
    if (this.scrollY > $("header").outerHeight()) {
        $('#notifications').addClass("divChatEvent-fixedContainer");
    } else {
        $('#notifications').removeClass("divChatEvent-fixedContainer");
    }

});

// zabrani pretazeni souboru kamkoli do stranky RQ
window.addEventListener("dragover", function (e) {
    e = e || event;
    e.preventDefault();
}, false);
window.addEventListener("drop", function (e) {
    e = e || event;
    e.preventDefault();
}, false);

$(document).mouseup(function (e) {
    var container = $(".popup");

    if (!container.is(e.target) // if the target of the click isn't the container...
        && (container.has(e.target).length === 0 || e.target.nodeName == "A")) // ... nor a descendant of the container or is a link
    {
        container.hide();
    }
});

function ReloadInternalNotification() {
    $("#InternalNotification_Layout").load(RQ_URL + "/InternalNotifications/InternalNotificationLayout");
}

function LoadNotifications() {
    $.post(
    RQ_URL + '/Notifications/NotificationsPopupData',
    {},
    function (data) {
        if (data == "LOGGED_OFF") {
            window.location = RQ_URL + "/";
        }
        else {
            $(data).each(function () {
                $.pnotify({
                    title: Localization_Notification,
                    text: '<em>' + this.created + '</em>: ' + this.message,
                    type: 'info',
                    shadow: true,
                    hide: !this.important
                    //stack: stack_bottomleft
                });
            });
        }
    },
    "json"
    )
    .fail(function (error) { /*alert(error.responseText);*/ })
    .done(function () { });
}


function startTime() {
    var stringTime = moment.utc(time).format('LLLL');
    var ss = moment.utc(time).format('ss');
    stringTime = ConcatenateSeconds(stringTime, ss);

    divClock.html(stringTime);

    time.setTime(time.getTime() + 1000);
    t = window.setTimeout('startTime()', 1000);
}

function ConcatenateSeconds(original, seconds) {
    var liodd = original.lastIndexOf(':');
    if (liodd != -1) {
        var iospace = original.indexOf(' ', liodd);
        if (iospace != -1) {
            return original.slice(0, iospace) + ':' + seconds + original.slice(iospace);
        }
        else {
            return original + ':' + seconds;
        }
    }

    return original;
}

function LicenseRemindMeLater() {
    $.post(
     RQ_URL + '/Desktop/LicenseRemindMeLater',
     {},
     function (data) {
         if (data == "OK") {
             $('#popup').slideUp();
         }
         else {
             alert(data);
         }
     },
     "json"
     )
     .fail(function (error) { alert(error.responseText); })
     .done(function () { });
}

function OnAjaxBegin(message) {
    $("#progressIndicator .waitingText").html(message === undefined || message.length === undefined ? Localization_LoadingPleaseWait : message);
    $("#progressIndicator").show();
}

function OnAjaxComplete() {
    $("#progressIndicator").hide();
    FadeOutSuccess();
}

function OnAjaxSuccess() {
    
}

function OnAjaxFailure(ajaxContext) {
    var response = ajaxContext.responseText;
    var statusCode = ajaxContext.status;
    alert('Failure ' + statusCode + ' ' + response);
    //Here you can do whatever you want with the div.
    //$('#ticketsDiv').empty();
}

//var intervalID;

function ShowSuccess(text) {
    //if (intervalID != null)
    //    window.clearInterval(intervalID);
    $('#lbSuccess').html(text);
    $('#ajax-success').fadeIn();
    if ($('#ajax-success').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-success').offset().top);
    }

    FadeOutSuccess();
}

function FadeOutSuccess() {
    setTimeout(function () {
        $("section#ajax-alert .alert.ok:not(.do-not-hide)").fadeOut('slow');
        $(".alert.alert-success").fadeOut('slow');
    }, 3000);

}

function HideSuccess() {
    //window.clearInterval(intervalID);
    $('#ajax-success').fadeOut();
}

function ShowInformation(text) {
    $('#lbInformation').html(text);
    $('#ajax-information').fadeIn();
    if ($('#ajax-information').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-information').offset().top);
    }
}

function HideInformation() {
    $('#ajax-information').fadeOut();
}

function ShowError(text) {
    $('#lbError').html(text);
    $('#ajax-error').fadeIn();
    if ($('#ajax-error').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-error').offset().top);
    }
}

function HideError() {
    $('#ajax-error').fadeOut();
}

function ShowWarning(text) {
    $('#lbWarning').html(text);
    $('#ajax-warning').fadeIn();
    if ($('#ajax-warning').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-warning').offset().top);
    }
}

function HideWarning() {
    $('#ajax-warning').fadeOut();
}

function HideAllMessageTypes() {
    HideSuccess();
    HideInformation();
    HideError();
    HideWarning();
}

function SearchableCombos() {
    $("select.searchable").select2({
        width: 'resolve',
    });

    $('select.searchable100').select2({ width: '100%' });

    $('select.searchableAllowClear100').select2({ width: '100%', allowClear: true, });

    $('select.searchable100HideDisabledOptions').select2({ width: '100%', dropdownCssClass: "select2-hide-disabled-items-in-dropdown" });

    $('select.searchableFontAwesome').select2({
        width: '100%',
        templateSelection: select2FormatFontAwesome,
        templateResult: select2FormatFontAwesome
    });
}

function Select2Combos() {
    $("select.select2").select2({
        minimumResultsForSearch: Infinity,
        width: 'resolve',
    });

    $("select.select2-100").select2({
        minimumResultsForSearch: Infinity,
        width: '100%',
    });

    $("select.select2AllowClear100").select2({
        minimumResultsForSearch: Infinity,
        width: '100%',
        allowClear: true,
    });
}

function LanguageSelect2() {
    $("select.language-select2").select2({
        minimumResultsForSearch: Infinity,
        templateSelection: select2FormatFlag,
        templateResult: select2FormatFlag,
        width: 'resolve',
    });

    $("select.language-select2-100").select2({
        minimumResultsForSearch: Infinity,
        templateSelection: select2FormatFlag,
        templateResult: select2FormatFlag,
        width: '100%',
    });
}

// Set the "bootstrap" theme as the default theme for all Select2
// widgets.
//
// @see https://github.com/select2/select2/issues/2927
$.fn.select2.defaults.set("theme", "bootstrap");
$.fn.modal.Constructor.prototype.enforceFocus = function () { }; //https://github.com/select2/select2/issues/1436

function jqgridDateTimeUtc2LocalFormatter(cellvalue, options, rowObject) {
    if (cellvalue) {
        var utcTime = moment.utc(cellvalue, moment.ISO_8601);
        var localTime = moment(utcTime.toDate());
        return localTime.format("l LTS");
    } else {
        return '';
    }
}

function initComboCustomForm(controlId, readOnly) {
    if ($("#" + controlId).data('select2')) { $("#" + controlId).select2("destroy").unbind("change"); }

    if (readOnly.toLowerCase() == "true") {
        $("#" + controlId).on("change", function (e) { comboCustomFormDependsChange(e); comboChangeItemSetNewDefaults(e); resetComboWihtDefault(e); });
        $("#" + controlId).hide();
    }
    else {
        $("#" + controlId).select2({ width: 'auto', dropdownAutoWidth: true })
                                           .on("change", function (e) { comboCustomFormDependsChange(e); comboChangeItemSetNewDefaults(e); resetComboWihtDefault(e); });
    }

    $.each($("#" + controlId), function (index, value) {
        try {
            $(value).trigger("change");
        }
        catch (err) {
        }
    });
}

function resetComboWihtDefault(e) {
    var haveTargets = window[$(e.currentTarget).attr("id") + "SourceDefaults"];
    if ($(e.currentTarget).val() == "" && haveTargets != undefined) {
        $.each(haveTargets, function (index, value) {
            $.each(value.SourceIds, function (index2, value2) {
                $("#Control" + value2.CustomFormFieldId).val("");
                try {
                    $("#Control" + value2.CustomFormFieldId).trigger("change");
                }
                catch (err) {
                }
            });
        });
    }
}

function comboChangeItemSetNewDefaults(e) {
    var haveSources = window[$(e.currentTarget).attr("id") + "SourceDefaults"];
    if ($("#" + $(e.currentTarget).attr("id") + "Span").length > 0) {
        $("#" + $(e.currentTarget).attr("id") + "Span").text($(e.currentTarget).find("option:selected").text());
    }

    if (haveSources != undefined) {
        $.each(haveSources, function (index, value) {
            //zvolil jsem prvek který má návazné prvky
            if (value.SourceId == $(e.currentTarget).val()) {
                $.each(value.SourceIds, function (index2, value2) {
                    $("#Control" + value2.CustomFormFieldId).val(value2.Id);
                    try {
                        $("#Control" + value2.CustomFormFieldId).trigger("change");
                    }
                    catch (err) {
                    }
                });
            }
        });
    }
}

function comboCustomFormDependsChange(e) {
    var myParentId = window[$(e.currentTarget).attr("id") + "Var"];
    var myChildren = window[$(e.currentTarget).attr("id") + "ChildrenVar"];
    var selectedValue = $(e.currentTarget).val();

    var parentItemId = -1;

    if (myChildren != undefined && myParentId != undefined) {
        $.each(myChildren, function (index, value) {
            var childrenIdSelect = "#Control" + value.Id;
            var valueChildren = $("#Control" + value.Id).val();

            if ($(childrenIdSelect).data('select2')) { $(childrenIdSelect).select2("destroy").unbind("change"); }

            $.each($(childrenIdSelect + " option"), function (index, value3) {
                if ($(value3).attr("value") != "") {
                    $(value3).remove();
                }
            });

            var rmv = true;
            $.each(value.Children, function (index2, value2) {
                if (selectedValue == "") {
                    rmv = false;
                    //set default options for select
                    $(childrenIdSelect).append("<option value='" + value2.Id + "' >" + value2.Text + "</option>");
                    try {
                        $(childrenIdSelect).trigger("change");
                    }
                    catch (err) {
                    }
                }
                else if (value2.ParentId == selectedValue) {
                    if (value2.Id == valueChildren) {
                        $(childrenIdSelect).append("<option value='" + value2.Id + "' selected='selected'>" + value2.Text + "</option>");
                        rmv = false;
                    }
                    else {
                        $(childrenIdSelect).append("<option value='" + value2.Id + "' >" + value2.Text + "</option>");
                        rmv = false;
                    }
                }
            });
            if (oneFromParentHasValue(value.ParentId) && selectedValue == "") {
                $.each($(childrenIdSelect + " option"), function (index, value3) {
                    if ($(value3).attr("value") != "") {
                        $(value3).remove();
                    }
                });
            }

            $(childrenIdSelect).select2({ width: 'auto', dropdownAutoWidth: true }).on("change", function (e) { comboChangeItemSetNewDefaults(e); comboCustomFormDependsChange(e); resetComboWihtDefault(e); });

            if ($(childrenIdSelect).val() == "") {
                try {
                    $(childrenIdSelect).trigger("change");
                }
                catch (err) {
                }
            }

            if (rmv) {
                try {
                    $(childrenIdSelect).trigger("change");
                }
                catch (err) {
                }
            }
        });

        $.each(myParentId, function (index, value) {
            if ($(e.currentTarget).attr("data-parentid")) {
                parentItemId = value.ParentId;
                var parentIdSelect = "#Control" + $(e.currentTarget).attr("data-parentid");
                if (value.Id == selectedValue && parentItemId != $(parentIdSelect).val()) {
                    $(parentIdSelect).val(parentItemId).trigger("change");
                }
            }
        });
    }
}

function oneFromParentHasValue(parentId) {
    if ($("#Control" + parentId).val() != "") {
        return true;
    }
    else {
        if ($("#Control" + parentId).attr("data-parentid") == "") {
            return false;
        }
        return oneFromParentHasValue($("#Control" + parentId).attr("data-parentid"));
    }
}

function initDateRangePicker(selector) {
    $(selector).daterangepicker({
        ranges: initRangesForDateRangePicker(),
        autoUpdateInput: false,
        locale: {
            format: moment.localeData().longDateFormat('L'),
            applyLabel: Localization_DateRangePicker_Apply,
            cancelLabel: Localization_DateRangePicker_Cancel,
            customRangeLabel: Localization_DateRangePicker_MyTimespan,
            firstDay: firstDayRange,
        }
    });
    
    $(selector).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(moment(picker.startDate).format('L') + ' - ' + moment(picker.endDate).format('L'));
    });

    $(selector).on('cancel.daterangepicker', function (ev, picker) {
        $(this).val('');
    });
}

function initBsTooltip() {
    var $selector = $('[data-toggle="tooltip"][title]');
    $selector.tooltipBS({ container: 'body', trigger: 'hover' });
    initBsTooltipHtml();
}

function initBsTooltipHtml() {
    $(".bs-tooltip-html").tooltipBS({ container: 'body', trigger: 'hover', html: true });
}

//pokud se meni ajaxem obsah stranky, muze zustat po replacu obsahu (partial) nejaky tooltip vazany na objekt, ktery uz neexistuje
function destroyAllBsTooltips() {
    $('.tooltip[role="tooltip"]').remove();
}

function openFeedbackDialog() {
    $("#dialog-feddback-attachments").empty();
    $("#dialogFeedbackDefault").show();
    $("#dialogSendFeedbackFail").hide();
    $("#dialogSendFeedbackAlright").hide();
    $("#dialogFeedbackSendButton").show();
    $("#ValidErrorEmail").hide();
    $("#ValidErrorSubject").hide();
    $("#ValidErrorEmailIsNotValid").hide();
    $("#dialogFeedbackEmail").val(dialogFeedbackDefaultEmail);
    $("#dialogFeedbackSubject").val("");
    $("#dialogFeedbackText").val("");
    $("#dialogFeedbackType").val("");
    $("#dialogFeedback").dialog("open");
}

function addFeedbackAttachmentInput() {
    var count = $("#dialog-feddback-attachments input").length;
    $("#dialog-feddback-attachments").append("<div class='dialog-feedback-padding-attachment'><input type='file' name='files'/><button class='btn btn-default' onclick='deleteFileInput(this)'><i class='fa fa-times'></i></button></div>");
}

function deleteFileInput(element) {
    $(element).closest(".dialog-feedback-padding-attachment").remove();
}

function GetServerNowUtc() {
    return moment.utc().add(timeCorrection, 'milliseconds');
}

function copyToClipboard(text, container) {
    var supported = document.queryCommandSupported("copy");

    if (supported) {

        if (container == null)
            container = $("body");

        var $temp = $("<input>", { style: "position:absolute;top:-1000px;left:-1000px;" });
        container.append($temp);
        $temp.val(text).select();

        // Check that the browser isn't Firefox pre-41
        try {
            document.execCommand("copy");
        } catch (e) {
            supported = false;
        }

        $temp.remove();
    }

    return supported;
}

jQuery.deparam = function (params) {
    var o = {};
    if (!params) return o;
    var a = params.split('&');
    for (var i = 0; i < a.length; i++) {
        var pair = a[i].split('=');
        o[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
    }
    return o;
}

function formatTicketSelection(state) {
    if (!state.id) return state.text; // kdyz se Select2 clearne, tak je tam text "Hledat"

    //jsou dve varianty, bud je to nactene pomoci ajaxu, nebo je to vyrenderovane do atributu data - tak to vymyslel T., proto je to nize dvojmo
    if (state.ticketREF === undefined) //do data elementu se to renderuje z predem vyrenderovanych polozek (nactenych do modelu stránky, _Task.cshtml)
        return $("<span><a href='" + RQ_URL + "/Tickets/Show/" + $(state.element).data("ticketref") + "' target='_blank'>" + $(state.element).data("subject") + "</a></span>");

    return $("<span><a href='" + RQ_URL + "/Tickets/Show/" + state.ticketREF + "' target='_blank'>" + state.subject + "</a></span>");
}

function formatTicketResult(ticket) {
    if (!ticket.id) return ticket.text; // kdyz tSelect2 vyhledava, tak je tam text "Vyhledavani..."

    var result = '<div class="select2-format-ticket">';
    result += '<div><span>' + htmlEncode(ticket.subject) + '</span> <span class="ticket-state">(' + htmlEncode(ticket.ticketState) + ')</span></div>';
    result += '<div class="ticket-details">';
    result += '<span class="ticketREF"><i class="fa fa-ticket" aria-hidden="true"></i> ' + ticket.ticketREF + '</span>';
    result += '<span><i class="fa fa-clock-o" aria-hidden="true"></i> ' + ticket.created + '</span>';
    result += '<span>';
    result += '<i class="fa fa-user" aria-hidden="true"></i> ' + htmlEncode(ticket.submitterFullName);

    if (ticket.submitterEmail != null)
        result += ' &lt;' + htmlEncode(ticket.submitterEmail) + '&gt;';

    result += '</span>';

    if (ticket.customerName != null) {
        result += '<span><i class="fa fa-building-o" aria-hidden="true"></i> ' + htmlEncode(ticket.customerName) + '</span>';
    }

    result += '</div>';
    result += '</div>';
    return $(result);
}

/// ticketview a tasks
function SaveEditTaskTrackTimeRecord(e) {
    $(e).closest(".track-time").find(".value .track-time-duration").data("durationstring", $(e).closest(".track-time").find(".edit .track-time-duration input").val());
    $(e).closest(".track-time").find(".value .track-time-description").data("description", $(e).closest(".track-time").find(".edit .track-time-description input").val());

    var data = createTrackTimeArray();
    $.ajax({
        url: RQ_URL + '/Tasks/GetTrackTimeRecords',
        data: JSON.stringify({
            data: data,
            DurationInString: $("#tbTaskTrackTimeRecordDuration").val(),
            Description: $("#tbTaskTrackTimeRecordDescription").val()
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            $("#tab_b").html(data);
        },
    });
}

function CloseEditTaskTrackTimeRecord(e) {
    $(e).closest(".track-time").find(".value").show();
    $(e).closest(".track-time").find(".edit").hide();
}

function EditTaskTrackTimeRecord(e) {
    $(e).closest(".track-time").find(".value").hide();
    $(e).closest(".track-time").find(".edit").show();
}

function DeleteTaskTrackTimeRecord(e) {
    $(e).closest(".track-time").remove();
}

function formatTaskCategorySelection(state) {
    if (state.element != undefined && $(state.element).data("color") != undefined && $(state.element).data("color") != "") {
        var text = "<div><div class='select2-background-circle' style='margin-top:2px;background-color:" + $(state.element).data("color") + "'></div><div style='margin-left:20px;'>" + state.text;
        if ($(state.element).data("share") == "True") {
            text += " <i class='fa fa-users' aria-hidden='true'></i>";
        }
        text += "</div></div>";
        return $(text);
    }
    return $("<div><div style='margin-left:20px;'>" + state.text + "</div></div>");
}

function formatTaskCategoryResult(state) {
    if (state.element != undefined && $(state.element).data("color") != undefined && $(state.element).data("color") != "") {
        var text = "<div><div class='select2-background-circle' style='margin-top:2px;background-color:" + $(state.element).data("color") + "'></div><div style='margin-left:20px;'>" + state.text;
        if ($(state.element).data("share") == "True") {
            text += " <i class='fa fa-users' aria-hidden='true'></i>";
        }
        text += "</div></div>";
        return $(text);
    }
    return $("<div><div style='margin-left:20px;'>" + state.text + "</div></div>");
}

function formatCustomerGroupSelection(state) {
    if (state.element != undefined && $(state.element).data("color") != undefined && $(state.element).data("color") != "") {
        var text = "<i class='fas fa-object-group' style='color: " + $(state.element).data("color") + "'></i> <a class='inline-block' href='" + RQ_URL + "/Admin/CustomerGroups/Edit/" + $(state.element).data("id") + "'>" + state.text + "</a>";
        return $(text);
    }
    return $("<div><div style='margin-left:20px;'>" + state.text + "</div></div>");
}

function formatCustomerGroupResult(state) {
    if (state.element != undefined && $(state.element).data("color") != undefined && $(state.element).data("color") != "") {
        var text = "<i class='fas fa-object-group' style='color: " + $(state.element).data("color") + "'></i> <span>" + state.text + "</span>";
        return $(text);
    }
    return $("<div><div style='margin-left:20px;'>" + state.text + "</div></div>");
}

function formatCustomerResult(state) {
    if (state.element != undefined && state != undefined) {
        var text = "<span>" + state.text + " <a href='" + RQ_URL + "/Customers/Edit/" + state.id + "' target='_blank'><i class='fas fa-external-link-square-alt'></i></a></span>";
        return $(text);
    }
    return $("<div>" + state.text + "</div>");
}

function formatCustomerData(state) {
    return $("<div>" + state.text + "</div>");
}

function formatProductItemResult(state) {
    if (state.loading) {
        return $("<div>" + state.text + "</div>");
    }
    if (state.children) {
        return $("<div>" + state.text + "</div>");
    }
    if (state != undefined) {
        var el = $(state.element);
        if (state.productFieldData == undefined) {
            state = el.data("attributes")
        }
        var text = "<div class='inline'><div>" + (state.productHasImage ? "<img src='" + RQ_URL + "/Products/GetProductIcon/" + state.productId + "' /> " : " <i class='" + state.productFontIcon + "'style='color:" + state.productColor + "'  ></i > ") + state.text;
        if (state.productCategoryExists) {
            text += " (" + "<i class='fas fa-briefcase' style='color:" + state.productCategoryColor + "'></i> " + state.productCategoryName + ")";
        }
        //text += "</div><div class='product-description'>" + state.description + "</div></div>";
        for (var i = 0; i < state.productFieldData.length; i++) {
            //Description
            if (state.productFieldData[i].FieldType == 1) {
                if (state.description != null) {
                    text += "<div class='gray'>Popis: ";
                    text += state.description;
                    text += "</div>";
                }
            }
            //Custom
            else if (state.productFieldData[i].FieldType == 1000) {
                //dropdown
                if (state.productFieldData[i].CustomFieldType == 1 && state.productFieldData[i].ProductFieldItemTitle != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].ProductFieldItemTitle;
                    text += "</div>";
                }
                //textbox || multiline
                else if ((state.productFieldData[i].CustomFieldType == 2 || state.productFieldData[i].CustomFieldType == 3) && state.productFieldData[i].TextBoxValue != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].TextBoxValue;
                    text += "</div>";
                }
                //numeric
                else if (state.productFieldData[i].CustomFieldType == 4 && state.productFieldData[i].LongValue != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].LongValue;
                    text += "</div>";
                }
                //decimal
                else if (state.productFieldData[i].CustomFieldType == 5 && state.productFieldData[i].DoubleValue != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].DoubleValue;
                    text += "</div>";
                }
                //checkbox
                else if (state.productFieldData[i].CustomFieldType == 6 && state.productFieldData[i].CheckBoxValue != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].CheckBoxValue ? Localization_Yes : Localization_No;
                    text += "</div>";
                }
                //date
                else if (state.productFieldData[i].CustomFieldType == 10 && state.productFieldData[i].DateValueString != null) {
                    text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                    text += state.productFieldData[i].DateValueString;
                    text += "</div>";
                }
                //url
                else if (state.productFieldData[i].CustomFieldType == 12) {
                    if (state.productFieldData[i].TextBoxValue != null) {
                        text += "<div class='gray'>" + state.productFieldData[i].CustomFieldTitle + ": ";
                        text += "<a href='" + (state.productFieldData[i].TextBoxValue.indexOf("://") == -1 ? "//" + state.productFieldData[i].TextBoxValue : state.productFieldData[i].TextBoxValue) + "'>" + state.productFieldData[i].TextBoxValue + "</a>";
                        text += "</div>";
                    }
                }
            }
        }
        text += "</div>";
        text += "</div>";
        return $(text);
    }
    return $("<div>" + state.text + "</div>");
}

function formatProductResult(state) {
    if (state.loading) {
        return $("<div>" + state.text + "</div>");
    }
    if (state != undefined) {
        var text = "<div class='inline'><div>" + (state.hasImage ? "<img src='" + RQ_URL + "/Products/GetProductIcon/" + state.id + "' /> " : " <i class='" + state.fontIcon + "'style='color:" + state.color + "'  ></i > ") + state.text + "</div></div>";
        return $(text);
    }
    return $("<div>" + state.text + "</div>");
}

function HideResultNotifications() {
    //nefunguje data - nepropíše se do css
    if ($("#notification_div").is(':visible')) {
        $("#notification_menu .has-badge").attr("data-count", "0");
        $("#notification_div").slideUp('fast');
    }
}

function LoadNextReadNotifications() {
    $.ajax({
        url: RQ_URL + '/Notifications/GetReadNotifications',
        data: JSON.stringify({
            date: $("#ReadNotifications .notification").last().data("createdutc"),
            lastDateForReadUtc: $("#LastDateForReadUtc").val()
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            $("#ReadNotifications").append(data);
        },
    });
}

function ShowReadNotifications() {
    LoadNextReadNotifications();
    $("#ReadNotificationsDiv").show();
    $("#HideReadNotification").show();
    $("#ShowReadNotification").hide();
}

function HideReadNotifications() {
    $("#ReadNotificationsDiv").hide();
    $("#HideReadNotification").hide();
    $("#ShowReadNotification").show();
}

function SetNotifications(count) {
    $("#notification_menu .has-badge").attr("data-count", "0");
}

function HideNextButtonForReadNotification() {
    $("#ShowNextReadNotification").hide();
}

function LoadAutomaticTicketAssignments() {
    if ($("#divAutomaticTicketAssignments").length) {
        $("#divAutomaticTicketAssignments").load(RQ_URL + "/Account/PartialUserAutomaticTicketAssignments", function () {
            initBsTooltipHtml();
        });
    }
}

function SetUserAvailablityForAutomaticTicketAssignment(id, available) {
    $.ajax({
        url: RQ_URL + '/Account/SetUserAvailablityForAutomaticTicketAssignment',
        data: JSON.stringify({
            id: id,
            available: available
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            if (available) {
                $("#divAutomaticTicketAssignments *[data-id='" + id + "'] i").css("color", "green");
            }
            else {
                $("#divAutomaticTicketAssignments *[data-id='" + id + "'] i").css("color", "red");
            }
        },
    });
}

function GlobalChangeAvailablityForAutomaticTicketAssignment(available) {
    $.ajax({
        url: RQ_URL + '/Account/GlobalChangeAvailablityForAutomaticTicketAssignment',
        data: JSON.stringify({
            available: available
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            LoadAutomaticTicketAssignments();
        },
    });
}

function rgb2hex(rgb) {
    rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
    function hex(x) {
        return ("0" + parseInt(x).toString(16)).slice(-2);
    }
    return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
}


var dayDurationPattern = /\d+d/g;
var hourDurationPattern = /\d+h/g;
var minuteDurationPattern = /\d+m/g;

function durationIsValid(duration) {
    return duration.match(dayDurationPattern) || duration.match(hourDurationPattern) || duration.match(minuteDurationPattern);
}

function parseDurationToMinutes(duration) {
    var totalMinutes = 0;
    if (durationIsValid(duration)) {
        if (duration.match(dayDurationPattern)) {
            var days = duration.match(dayDurationPattern);
            for (var i = 0; i < days.length; i++) {
                totalMinutes += Number(days[i].replace("d", "")) * 24 * 60;
            }
        }
        if (duration.match(hourDurationPattern)) {
            var hours = duration.match(hourDurationPattern);
            for (var i = 0; i < hours.length; i++) {
                totalMinutes += Number(hours[i].replace("h", "")) * 60;
            }
        }
        if (duration.match(minuteDurationPattern)) {
            var minutes = duration.match(minuteDurationPattern);
            for (var i = 0; i < minutes.length; i++) {
                totalMinutes += Number(minutes[i].replace("m", ""));
            }
        }
    }
    return totalMinutes;
}

function openDatePicker(datePickerId) {
    $(datePickerId).datepicker("show");
}

function openTimePicker(timePickerId) {
    $(timePickerId).timepicker("show");
}

function changeLanguage(value) {
    $.post(
        RQ_URL + '/Home/ChangeLanguage',
        { code: value },
        function (data) {
        },
        "json"
    )
    .fail(function (error) { alert(error.responseText); })
    .done(function () { window.location.reload(); });
}

function select2FormatFlag(flag) {
    if (!flag.id) {
        return flag.text;
    }
    var baseUrl = RQ_URL + "/Images/Flags";

    var image = $(flag.element).data("flagimage");
    var $flag = $(
        '<span>' +
        (image != "" ? '<img src="' + baseUrl + '/' + image + '" class="img-flag" /> ' : "")
        + flag.text + '</span>'
    );
    return $flag;
}

function formatUsersForSelect2AjaxData(user) {
    var userCustomers = "";
    if (user.customers != null) {
        if (user.customers.length > 1) {
            // pokud ma uzivatel vice spolecnosti, tak se u default (prvni v seznamu) zobrazi "domecek"
            userCustomers = '<i class="fal fa-home"></i> ';
        }

        for (var i = 0; i < user.customers.length; i++) {            
            userCustomers += '<i class="far fa-building"></i> ' + htmlEncode(user.customers[i].customerName) + ', ';
        }

        if (userCustomers.length > 0 && userCustomers.endsWith(', '))
            userCustomers = userCustomers.substring(0, userCustomers.length - 2);
    }    

    return (user.domain ? ' <i class="fab fa-windows" title="' + htmlEncode(user.domain) + '"></i> ' : '') +
        (user.isApproved != null && user.isApproved === false ? '<i class="fas fa-user-slash" title="' + Localization_Disabled + '"></i> ' : '') +
        htmlEncode(user.text) +
        (user.roleAbbrev ? ' (' + htmlEncode(user.roleAbbrev) + ')' : '') +
        (user.email ? ' <span class="email">&lt;' + htmlEncode(user.email) + '&gt;</span>' : '') +
        userCustomers;        
}

function formatUsersForSelect2AjaxElement(user) {
    var el = $(user.element);

    if (!user.domain && el.data("domain"))
        user.domain = el.data("domain");

    if (typeof user.isApproved === "undefined" && typeof el.data("is-approved") !== 'undefined') 
        user.isApproved = (el.data("is-approved") === true);
    
    if (!user.roleAbbrev && el.data("role-abbrev"))
        user.roleAbbrev = el.data("role-abbrev");

    if (!user.email && el.data("email"))
        user.email = el.data("email");

    if (!user.customerId && el.data("customer-id"))
        user.customerId = el.data("customer-id");

    if (!user.customerName && el.data("customer-name"))
        user.customerName = el.data("customer-name");   

    if (!user.initials && el.data("initials"))
        user.initials = el.data("initials");

    if (!user.avatarColor && el.data("avatar-color"))
        user.avatarColor = el.data("avatar-color");

    if (typeof user.anonymized === "undefined" && typeof el.data("anonymized") !== 'undefined')
        user.anonymized = (el.data("anonymized") === true);

    if (typeof user.hasPhoto === "undefined" && typeof el.data("has-photo") !== 'undefined')
        user.hasPhoto = (el.data("has-photo") === true);

    if (!user.photoUrlHash && el.data("photo-url-hash"))
        user.photoUrlHash = el.data("photo-url-hash");

    if (!user.customers && el.data("customers")) {
        user.customers = el.data("customers");
    }        

    return formatUsersForSelect2AjaxData(user);
}

function userAvatar(userproviderkey, fullname, initials, color, hasPhoto, photoUrlHash, anonymized, deleted, size, cssClass) {
    if (cssClass === undefined)
        cssClass = '';

    if (size == 'small')
        cssClass += ' badge-small';
    else if (size == 'smaller')
        cssClass += ' badge-smaller';

    if (anonymized)
        cssClass += ' user-anonymized';

    if (deleted)
        cssClass += ' user-deleted';

    var html = "<div class='timeline-badge " + cssClass + "' title='";

    if (deleted) {
        html += "deleted'>-</div>";
    }

    html += htmlEncode(fullname) + "'";

    if (anonymized) {
        html += "><i class='fad fa-user-secret fa-2x' aria-hidden='true'></i></div>";
    }

    if (hasPhoto) {
        var params = photoUrlHash ? "?hash=" + photoUrlHash : "";
        html += " style=\"background-image: url('" + RQ_URL + '/Account/GetUserPhoto/' + userproviderkey + params + "')\">";
    }
    else {
        html += " style='background-color: " + color + "'>" + htmlEncode(initials);
    }

    html += "</div>";

    return html;
}

function formatEmailsAndAliases(item) {
    var el = $(item.element);
    var alias = el.data("alias") === true;
    var iconClass = alias ? 'far fa-at' : 'far fa-envelope';
    return htmlEncode(item.text) + ' <i class="' + iconClass + ' fa-fw" title="' + (alias ? "alias" : "mailbox") + '"></i> &lt;' + el.data("email") + '&gt;';
}

function AnimateRotateOnce(selector) {
    $(selector).addClass('rotating-animation');
    setTimeout(function () { $(selector).removeClass('rotating-animation'); }, 1000);
}

function select2FormatFontAwesome(icon) {
    if (!icon.id) {
        return icon.text;
    }
    
    var $icon = $(
        '<span>' +
        '<i class="' + icon.id+' fa-fw" /> ' 
        + icon.text + '</span>'
    );

    return $icon;
}

function select2FormatOneIconAndMoreColors(option) {
    if (!option.id) { { return option.text; } }
    var $formatedOption = $(
        '<i class="fa ' + $(option.element).closest("select").data("fontawesomeclass") + '" aria-hidden="true" style="color:' + $(option.element).data("background") + '"></i> <span>' + option.text + '</span>'
    );
    return $formatedOption;
}

function formatUserGroupsForSelect2AjaxData(group, isInternalGroup, isOperatorGroup) {
    if (isInternalGroup)
        return (group.domain ? ' <i class="fab fa-windows fa-fw" title="' + group.domain + '" style="color:' + group.color + '"></i>' : ' <i class="fas fa-users" style="color:' + group.color + '"></i>') + "<span> " + group.text + (group.numberOfUsers ? " (" + group.numberOfUsers + ")" : "") + (group.showlink ? " <a href='" + RQ_URL + "/InternalGroups/Edit/" + group.id + "' target='_blank'><i class='fas fa-external-link-square-alt'></i></a></span>" : "");
    if (isOperatorGroup)
        return (group.domain ? ' <i class="fab fa-windows fa-fw" title="' + group.domain + '" style="color:' + group.color + '"></i>' : ' <i class="fas fa-users" style="color:' + group.color + '"></i>') + "<span> " + group.text + (group.numberOfUsers ? " (" + group.numberOfUsers + ")" : "") + (group.showlink ? " <a href='" + RQ_URL + "/OperatorGroups/Edit/" + group.id + "' target='_blank'><i class='fas fa-external-link-square-alt'></i></a></span>" : "");
    //tohle by nemělo nastat
    return (group.domain ? ' <i class="fab fa-windows fa-fw" title="' + group.domain + '" style="color:' + group.color + '"></i>' : ' <i class="fas fa-users" style="color:' + group.color + '"></i>') + "<span> " + group.text + (group.numberOfUsers ? " (" + group.numberOfUsers + ")" : "") + "</span>";
}

function formatUserGroupsForSelect2AjaxElement(group, isInternalGroup, isOperatorGroup) {
    var el = $(group.element);

    if (!group.domain && el.data("domain"))
        group.domain = el.data("domain");

    if (!group.color && el.data("color"))
        group.color = el.data("color");

    if (!group.numberOfUsers && el.data("numberofusers"))
        group.numberOfUsers = el.data("numberofusers");

    if (!group.showlink && el.data("showlink"))
        group.showlink = el.data("showlink");

    return formatUserGroupsForSelect2AjaxData(group, isInternalGroup, isOperatorGroup);
}

function formatUserInternalGroupsForSelect2AjaxData(group) {
    return formatUserGroupsForSelect2AjaxData(group, true, false);
}

function formatUserInternalGroupsForSelect2AjaxElement(group) {
    return formatUserGroupsForSelect2AjaxElement(group, true, false);
}

function formatUserOperatorGroupsForSelect2AjaxData(group) {
    return formatUserGroupsForSelect2AjaxData(group, false, true);
}

function formatUserOperatorGroupsForSelect2AjaxElement(group) {
    return formatUserGroupsForSelect2AjaxElement(group, false, true);
}

function productItemCustomFieldsFormatter(cellValue, options, rowObject) {
    var html = "";
    for (var i = 0; i < rowObject.ProductFieldData.length; i++) {
        html += "<div class='gray'>";
        if (rowObject.ProductFieldData[i].DoNotShowInTicket) {
            html += "<s>";
        }
        html += rowObject.ProductFieldData[i].CustomFieldTitle + ": ";
        //dropdown
        if (rowObject.ProductFieldData[i].CustomFieldType == 1 && rowObject.ProductFieldData[i].ProductFieldItemTitle != null) {
            html += rowObject.ProductFieldData[i].ProductFieldItemTitle;
        }
        //textbox || multiline
        else if ((rowObject.ProductFieldData[i].CustomFieldType == 2 || rowObject.ProductFieldData[i].CustomFieldType == 3) && rowObject.ProductFieldData[i].TextBoxValue != null) {
            html += rowObject.ProductFieldData[i].TextBoxValue;
        }
        //numeric
        else if (rowObject.ProductFieldData[i].CustomFieldType == 4 && rowObject.ProductFieldData[i].LongValue != null) {
            html += rowObject.ProductFieldData[i].LongValue;
        }
        //decimal
        else if (rowObject.ProductFieldData[i].CustomFieldType == 5 && rowObject.ProductFieldData[i].DoubleValue != null) {
            html += rowObject.ProductFieldData[i].DoubleValue;
        }
        //checkbox
        else if (rowObject.ProductFieldData[i].CustomFieldType == 6 && rowObject.ProductFieldData[i].CheckBoxValue != null) {
            html += rowObject.ProductFieldData[i].CheckBoxValue ? Localization_Yes : Localization_No;
        }
        //date
        else if (rowObject.ProductFieldData[i].CustomFieldType == 10 && rowObject.ProductFieldData[i].DateValueString != null) {
            html += rowObject.ProductFieldData[i].DateValueString;
        }
        //url
        else if (rowObject.ProductFieldData[i].CustomFieldType == 12) {
            if (rowObject.ProductFieldData[i].TextBoxValue != null) {
                html += "<a href='" + (rowObject.ProductFieldData[i].TextBoxValue.indexOf("://") == -1 ? "//" + rowObject.ProductFieldData[i].TextBoxValue : rowObject.ProductFieldData[i].TextBoxValue) + "'>" + rowObject.ProductFieldData[i].TextBoxValue + "</a>";
            }
        }
        if (rowObject.ProductFieldData[i].DoNotShowInTicket) {
            html += "</s>";
        }
        html += "</div>";
    }
    return html;
}

function toggleFaAngleDoubleIcon($bt) {
    var i = $bt.find('i.fa');
    i.toggleClass('fa-angle-double-down');
    i.toggleClass('fa-angle-double-up');
}

function formatCustomersForSelect2AjaxData(customer) {
    var html = "";
    if (customer.isDisabled != null && customer.isDisabled == true) {
        html += '<i class="fas fa-ban text-danger"></i> ';
    }

    if (customer.id) {
        html += "<span> " + htmlEncode(customer.text) + " <a href='" + RQ_URL + "/Customers/Edit/" + customer.id + "' target='_blank'><i class='fas fa-external-link-square-alt'></i></a></span>";
    }

    return html;
}

function formatCustomersForSelect2AjaxElement(customer) {
    var el = $(customer.element);

    if (typeof customer.isDisabled === "undefined" && typeof el.data("is-disabled") !== 'undefined')
        customer.isDisabled = (el.data("is-disabled") === true);

    return formatCustomersForSelect2AjaxData(customer);
}

function formatOptionGroupSelect(state) {
    if (!state.id) { return htmlEncode(state.text); }
    var groupName = "";
    if ($(state.element).closest("optgroup").length > 0) {
        groupName = $($(state.element).closest("optgroup")).attr("label") + "/";
    }
    var $state = $(
        '<span>' + htmlEncode(groupName) + htmlEncode(state.text) + '</span>'
    );
    return $state;
};